﻿#targetengine 'scriptPalette'
try{//если функция еще не загружена в targetengine - загружаем
delete scriptPalette_main;//для отладки
scriptPalette_main;
}catch(err){
scriptPalette_main = function(){
	
/* ======= ! ! ! =========*/
// If you create sets are not stored, into this variable can enter the path to the service directory of script
// Если создаваемые наборы не сохраняются - в эту переменную можно вписать путь к служебной папке скрипта.

var USER_FOLDER = "";

/* Example, пример: var USER_FOLDER = "D:/Works/Scripts/scriptPalette";
/* ======= ! ! ! =========*/

//=============================================
var help = "To create and edit sets of buttons and lists, use the context menu that is called by right-clicking.\r\r";
help += "If you create sets are not saved, open the script and change the line 'var USER_FOLDER = \"\";'.\r";
help += "For example:  'var USER_FOLDER = \"D:/Works/Scripts/scriptPalette\";'.\r\r";
/*help += "For CS5:\r";
help += "Not recommended to run this script through the plug-in 'Script Bay'.\r\r";*/
help += "\r";
help += "Для создания и редактирования наборов кнопок и списков используйте контекстное меню, которое вызывается щелчком правой кнопки мыши.\r\r";
help += "Если создаваемые наборы не сохраняются, откройте скрипт и измените строку 'var USER_FOLDER = \"\";'.\r"
help += "Например:  'var USER_FOLDER = \"D:/Works/Scripts/scriptPalette\";'.\r\r";
/*help += "Для CS5:\r";
help += "Не рекомендуется запускать этот скрипт через плагин 'Script Bay'.\r";*/
//=============================================
var script = getScriptLibrary( {
//	scriptFile: scriptFile, 
	name: 'scriptPalette', 
	version: 4.01, 
	release: 2014, 
	supportApp: [ 'InDesign6', 'Illustrator14' ], 
	prefsInit: true, 
	targetengine: true
	} );
if(!script.systemCheck())
	return;
//script.language = 'en'; // en/ru. Принудительное определение языка интерфейса
script.initXMLOptions();// подгружаем настройки

extension_scriptInfo( script );
extension_contextMenu( script );
extension_customDraw( script );
//extension_colorPicker( script );

var OPTIONS = script.sourceToObject( script.getUserXMLOptions().@source.toString() ); // return Object or null
if( !OPTIONS )
	OPTIONS = getDefaultOptions();

var win = false;
var thisCS = script.appVersionCS();
var closeApp = false;
var fsTypes = ['file  ','folder  '];
var currentGroupIndex = null;
var iconsFieldColor = [225,225,225];

var CHANGES = {
	access: true,
	status: false,
	setStatus: function(){
		if( this.access )
			this.status = true;
		}
	}
var runAIMetods = {
	 "Execute file": { metod: function( fsObject ){ fsObject.execute() }, supportCS: 0, note: "Attention!\n To use this method, put the top line of the script:\n #target 'illustrator'" },
	 "BridgeTalk": { metod: function( fsObject ){ var jsSource = script.fileRead( fsObject ); if( !jsSource ) return; var bt = new BridgeTalk; bt.target = 'illustrator'; bt.body = jsSource; bt.send(); }, supportCS: 3 },
	 "executeScript": { metod: function( fsObject ){ var jsSource = script.fileRead( fsObject ); if( !jsSource ) return; illustrator.executeScript( jsSource ) }, supportCS: 4 },
	 "evalFile": { metod: function( fsObject ){ evalScript_function( fsObject ) }, supportCS: 3 },
	}
var UPDATE_FOCUS_VBS_FILE;

var regExpFileFilterForAutoList = new RegExp( "\\.(js|jsx|jsxbin|" +(File.fs == 'Windows'  ? "vbs" : "applescript")+ "|)$", 'i' );

//================ LOCALIZE ===============================
script.messages.ru["show button"] = 'показывать кнопку';
script.messages.ru["autostart"] = 'автозапуск';
script.messages.ru["autosave changes"] = 'автосохранение изменений';
script.messages.ru["use relative links"] = 'использовать относительные ссылки';
script.messages.ru["toggle keyboard focus in Control Panel after execute"] = 'после выполнения переключать фокус клавиатуры в палитру «Управление»';

//================ START ===============================
addScriptImages();
createPalette();
palette_ContextMenu();
loadSets();
activateOptions();
//beforeQuitAppListener(); // не работает
win.show();
//=====================================================
function beforeQuitAppListener(){ // for InDesign CS5 and late
	if( !app.hasOwnProperty('addEventListener') )
		return;
	try{
		app.addEventListener( 'beforeQuit', function(){ if(CHANGES.status && OPTIONS.autoSave) saveSets(true) } );
		}catch(err){}
	}
function saveProperties(){
	// сохраняем настройки
	script.getUserXMLOptions().@source = script.objectToSource( getOptions() );
	// СОХРАНЯЕМ НАСТРОЙКИ
	script.saveXMLOptions();
	}
function getDefaultOptions(){
	return {
		showOptionsButton:true,
		location:[100,100], 
		orientation:'column', 
		buttonsWidth:200, 
		currentGroup:0, 
		relativeLinks:true, 
		autoSave:true,
		debugFocus: false,
		changeMetodIllustrator:"BridgeTalk",
		activeMethods:{
			"Execute file": true,
			 "BridgeTalk":true,
			 "executeScript": false,
			 "evalFile": false
			}
		};
	}
function getOptions(){ // обновляет данные опций и возвращает объект опций
	try{
	for(var i = 0; i < win.Frame.Grps.children.length; i++)
		if(win.Frame.Grps.children[i].visible)
			break;
	OPTIONS.location = [win.location[0],win.location[1]];
	OPTIONS.orientation = win.orientation;
	OPTIONS.currentGroup = i;
//	return false;
	return OPTIONS;
	}catch(err){ script.alertError(err); return false; }
	}
function activateOptions(){
	try{
	win.location = OPTIONS.location;
	if( !OPTIONS.buttonsWidth ) OPTIONS.buttonsWidth = 200;
	paletteOrientation( OPTIONS.orientation );
	if(win.Tabs.children.length > OPTIONS.currentGroup)
		win.Tabs.children[OPTIONS.currentGroup].onClick();
	else if(win.Tabs.children.length > 0)
		win.Tabs.children[0].onClick();
	return true;
	}catch(err){
//		activateOptions( getDefaultOptions() );
		script.alertError(err); return false;
		}
	}
//=====================================================
function addScriptImages(){
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x10\x00\x00\x00\x10\b\x06\x00\x00\x00\x1F\u00F3\u00FFa\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x021IDATx\u00DA\u00A4S\u00B9\u008A\"Q\x14\u00BD\u00E5\u00D6\"*\u00EE\x18\u00B84\u0088\n\"4\u0082\u008A\u00A0\u00A0\r\u0086\u00E6\u00FE\u0080\u0098\x1A\x1A\u00AA\u00FF`b\u00D8\u00A1\u0099\u0081\u00A1\u00E0\f\n\u00AD(Hc\u00E6\u009A(\u0088\u00BB\u0091\u00B8O\u009D\u0087\u00CA\f3\x1D\u00CD\u0083[u\u00EA\u00DEs^\u00DDz\u00E7\x16W(\x14\u00E8\u009B\u0095\u00E5#s\u00C7\u00B9\u00FB\u00F3_Kp\u00BD^)\x1A\u008D\x12\x7F\u00CF\u00F2Q\x05\u00BE?g\u00BE\u00C1Up\u00EF\u0098\u00B8|>\u00FF|\u009B\u00CF\u00E7\u00A3\u00E1pH\x1A\u008D\u0086\u00D4j5i\u00B5Z\u00BA\u00DDn\u00B4^\u00AFi\u00B3\u00D9\u00B0\u00BB\u00CDf\u00A3V\u00AB\u00F5\u00ECJt\u00B9\\\u00F0\x10\u00F6z\u00BD\u00A4\u00D3\u00E9H\u00A9T2\u00E2b\u00B1`\x18\x0B\x18\x1BZ\u00ADV\u0092H$\u00E4\u00F1x\u00A8\u00DDn\u0087\u00D9'`\u0083X,\u00F6\u00DE\u00EF\u00F7i\u00BF\u00DF\u0093@ `d\u00BB\u00DDNb\u00B1\u0098\x050r\u00A8\u0081\x03.4\u00D0\u008A\u00CE\u00E73{\u008BB\u00A1\u00A0\u00F9|Nz\u00BD\u009E^^^\u00A8\u00D1hP\u00BD^g\u00B5P(D\u0081@\u0080\x0E\u0087\x03\u00EB\x06\\,h\x05\u00FC%[,\x16oH\u00A2(\x14\n\u00D1\x1E\u00E2G:\u009D\u00E6\x10\u00C0\u00C8\u00A1\u00F6\u00D8\x00\x1Ah\u00B1A&\x1E\u008F\u0093\u00D1h$\u00B3\u00D9L\"\u0091\u0088\u00BA\u00DD.\u00A5R\u00A9\u00F7\u0087U\u00C0\u00C8\u00A1\x06\x0E\u00B8\u00D0@+:\u009DN4\u0099L\u00FE\u00F0\u00F6\u00D1\u00E2\u00BFr\u00E0\u00C3\x11\x04\u00B00\x18\fr\u0083\u00C1 \u0082\x13\u009FN\u00A7d0\x18H.\u0097\u00D3\u00E7\u00E7g\u00C4\u00E1p|@T.\u0097\u00ABn\u00B7\u00FBU*\u0095\u00B2\u00EEpx\u00B5Z\rs\u0090cg\u0090H$\u00B8\u00E5r\u00C9\u0084\u00BB\u00DD\u008E\u00D9\u00E5r\u00B9\"\u0095J\u00E5\u0086\x00F\x0E5p\u00C0\u0085\x06\u00DA\u00A7\x0B8\x1C\u0093\u00C9\u00C4\x1C\u0098\u00CDf\u00CC6L\x1B\x16\u00DAEN&\u0093\u00B1\r`\u00E3\u00C3\x05\u00A1\u00DF\u00EF\u00A7f\u00B3Yu:\u009D\u00AF\x18\u00A6\u00D1h\u00C4\u00C8\u00BD^\u008F\u008E\u00C7#\u00B3\u00F6\u00EB\u00EB\u008BY\u0088\u00D6\u00F9O\u00A1\u00EDvK\u00A5R)\u00C2O\u00E9\u00C7c\x12\x7F\u00F26E\u0080\u00C7\u00E31{\u00BBJ\u00A5\u00A2\u00DFgd\u00B5Z\x11\x7FV\u00AC\u00FDN\u00A7\u00C34\u00CFI\f\u0087\u00C3Y\u00FE\u009E\u0083\u00DFooo\u009C\u00C5b\u0081\u00F7\u00ECgA\x00#\u0087\x1A8\u00E0\u00DE5\u00C4%\u0093\u00C9\u00FF\u00FA\u009D\x7F\t0\x00I\\i\u00A5H\x00\u00EA^\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'settings');
	var code = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\n\x00\x00\x00\n\b\x06\x00\x00\x00\u008D2\u00CF\u00BD\x00\x00\x00\x04gAMA\x00\x00\u00AF\u00C87\x05\u008A\u00E9\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\u00F8IDATx\u00DAb\u00B9\u00BB\u008A\x01\x1D\u00FC\u0087\u00D2\u008C\u00C8\u0082L\x7F\u00FE00(\u0085\u00DE\x05c \u00BB\u0081_3\u009F\x01\u0084Al$q\x06\u00A6\u00DF\u00BF\x11\u00BA\u0080\u00ECza\u009D<\x06\x10\x06\u00B1\u0091\u00C4\x19X~\u00FDb\u00D8\x7F~\u008E\u00B2\x03H@R?\u0091\u0081\u00E1\u00D7S\u00B0\u00A4\u00B0f\"\x03P\x1C\u00E6\u008C\x03\u008C\u00C7\u00A70\u00FC\u00B7\u00C8\u00BE\u00CB\u00C0\u00F0q?\x03V\u00C0\u00EF\u00C8pb\u00AA2\x03\u00E3\u0081^\x06\u0090i\u00FB\x15t,\x18\u00E4u\u00CCQ\u00D4<\u00BCr\u0092\u00E1\u00C1\u0095\x13 \u00A6#\u00CB\u00CF\u009F\f\x07\u0080\u008C\u00C6\u00D7\u008Fn\u00D4\u00CB+q\u00A2(\x04\u008A1\x00\u00E5\x1BAV\u0083\u00DC\b\x02\u00F6\u008AJ,\f\f\u00DFo1\u00BC}\u00FD\x13\u00E2FQv\x06\u0090\u00D8\u008B\u00A7\f\u00F6 >\x0B\u00D4\u00D7\x0E\u00C2\u00FCo\x18n\\b`\u00B8~\x1Dl\x03\u0083\u00A6&\u0083\u0083\u0086\x06\u00D8\u00C7`\u008F2\u00AE*\x07+\x04\u00F9\x04$\x00\u00B2\u00A6\x01j3\u0088\x06\x05\x11H\u00A3#@\u0080\x01\x00\u00E4\u00A4\\\u00D7\u00D6\u00C8\u00FF\u00F7\x00\x00\x00\x00IEND\u00AEB`\u0082";
	script.writeImage(code, 'default_icon');
	}
//=====================================================
function getAdaptFsName(fsObjectOrPath){
	var fsName = fsObjectOrPath.constructor == String ? fsObjectOrPath : fsObjectOrPath.fsName;
	if( OPTIONS.relativeLinks )
		var link = script.adaptFsNameForSave( fsName.replace(script.file.parent.fsName, '.') );
	else
		var link = script.adaptFsNameForSave( fsName );
	if(fsObjectOrPath instanceof Folder)
		link += '/';
	return link;
	}
function getFsObject(adaptFsName){//return File or Folder
	if(adaptFsName.charAt(0) == '.')
		adaptFsName = script.file.parent.fsName + adaptFsName.substr(1);
	if(File.fs == 'Macintosh' && !(/^[.\/]/.test(adaptFsName)))
		adaptFsName = '/' + adaptFsName;
	var obj = (adaptFsName.substr(-1) == '/') ? Folder(adaptFsName) : File(adaptFsName);
	return obj;
	}
function launchFsObject(path, thisButton){
	try{
	var fsObject = getFsObject(path);
	if(!fsObject.exists){
		alert(fsObject.constructor.name + " '" + fsObject.fsName + "' not found!");
//		alert('Error:\r' + fsObject.fsName + '\ris not found!');
//		thisButton.enabled = false;
		return;
		}
	if(fsObject instanceof Folder)
		return fsObject.execute();
	var type = 0;
	var extension = path.substr(path.lastIndexOf('.')+1).toLowerCase();
	if(script.appName == 'Illustrator'){
		switch( extension ){
			case 'js':
			case 'jsx':
			case 'jsxbin':
			var metod = false;
			var names = [];
			for( var m in runAIMetods )
				if( OPTIONS.activeMethods[m] && thisCS >= runAIMetods[m].supportCS )
					names.push( m );
			if( !names.length ) {
				alert( 'No selected methods for .js/.jsx' );
				return;
				}
			else if( names.length == 1 )
				return runAIMetods[names[0]].metod( fsObject );
				
			var win = new Window('dialog');
			win.margins =win.spacing =  5;
			with(win){
				win.sText = add('statictext', undefined, 'Choose method of running a script');
				win.Grp = add('group');
				win.Grp.orientation = 'row';
				with(win.Grp){
					for( var i = 0; i < names.length; i++ ){
						win.Grp[names[i]] = add("button", undefined, names[i]);
						if( runAIMetods[names[i]].note ) win.Grp[names[i]].helpTip = runAIMetods[names[i]].note;
						win.Grp[names[i]].onClick = function(){ metod = OPTIONS.changeMetodIllustrator = this.text; this.window.close(); }
						}
					}
				};
			win.defaultElement =  win.Grp[OPTIONS.changeMetodIllustrator]? win.Grp[OPTIONS.changeMetodIllustrator] : win.Grp.children[0];
				
			var shift = ($.screens[0].right - thisButton.window.location[0]) < (100*win.Grp.children.length) ? -100*win.Grp.children.length : 0;
			win.location = [thisButton.window.location[0]+thisButton.windowBounds[0]+(thisButton.size[0]/2)+shift, thisButton.window.location[1]+thisButton.windowBounds[1]+(thisButton.size[1]/2)];
			win.show();
			
			if( metod )
				runAIMetods[metod].metod( fsObject );
			break;
			default:
			fsObject.execute();
			}
		return;
		}
	//InDesign
	switch( extension ){
		case 'js':
		case 'jsx':
		case 'jsxbin':
		type = 1246973031;//ScriptLanguage.javascript
		break;
		case 'vbs':
		type = 1447185511;//ScriptLanguage.VISUAL_BASIC
		break;
		case 'applescript':
		type = 1095978087;//ScriptLanguage.APPLESCRIPT_LANGUAGE
		}
	if(!type)
		return fsObject.execute();
	app.doScript(fsObject, type);
	
	if( File.fs == 'Windows' && OPTIONS.debugFocus ){
		// боремся с багом фокуса - вызываем команду меню "Виды, навигация / Переключить фокус клавиатуры в палитру «Управление»"
		app.menuActions.itemByID(70914).invoke();
		}
	/*
	// обновляем фокус
	if( File.fs == 'Windows' ){
		if( !UPDATE_FOCUS_VBS_FILE ){
			UPDATE_FOCUS_VBS_FILE = new File( Folder.temp.absoluteURI + '/update_focus.vbs' );
			var vbs_str = 
'Set WShell = CreateObject("WScript.Shell")\
WShell.Run "Notepad.exe"\
WScript.Sleep 300\
WShell.SendKeys "%{F4}"';
			if( UPDATE_FOCUS_VBS_FILE.exists ){
				if( script.fileRead(UPDATE_FOCUS_VBS_FILE) != vbs_str ){
					script.fileWrite( UPDATE_FOCUS_VBS_FILE, vbs_str );
					alert( 'File ' + UPDATE_FOCUS_VBS_FILE.displayName + ' updated' );
					}
				}
			else
				script.fileWrite( UPDATE_FOCUS_VBS_FILE, vbs_str );
			}
		UPDATE_FOCUS_VBS_FILE.execute();
		}
	*/
	}catch(err){script.alertError(err)};
	}

//================ PALETTE ===============================
function createPalette(){
	// UI-объект Group не имеет properties, поэтому для идентифицируем групп используем заказные свойства самого объекта
	try{
	var item;
	win = new Window('palette', script.name);
	win.preferredSize = [20,20];
	win.margins = 0;
	win.spacing = 0;
	
	win.Tabs = win.add('group');
	win.Tabs.orientation = 'row';
	win.Tabs.margins = [3,3,3,3];
	win.Tabs.spacing = 5;
	win.Tabs.isTabsGroup = true;
	
	win.Line = win.add('panel');
	win.Line.alignment = ['fill', 'top'];
	win.Line.preferredSize.height = 2;
	
	win.IconsField_Top = win.add('group');
	win.IconsField_Top.orientation = 'row';
	win.IconsField_Top.alignment = ['fill', 'top'];
	win.IconsField_Top.alignChildren = ['left', 'top'];
	win.IconsField_Top.margins = [3,2,3,2];
	win.IconsField_Top.spacing = 5;
	win.IconsField_Top.preferredSize.height = 30;
	script.addColor( win.IconsField_Top, 0, iconsFieldColor );
	win.IconsField_Top.isIconsField = true;
	win.IconsField_Top.isIconsField_Top = true;
	
	win.Frame = win.add('group');
	win.Frame.orientation = 'row';
	win.Frame.alignment = ['fill', 'top'];
	win.Frame.margins = 0;
	win.Frame.spacing = 0;
	
	win.Frame.IconsField_Left = win.Frame.add('group');
	win.Frame.IconsField_Left.orientation = 'column';
	win.Frame.IconsField_Left.alignment = ['left', 'fill'];
	win.Frame.IconsField_Left.alignChildren = ['left', 'top'];
	win.Frame.IconsField_Left.margins = [3,3,5,3];
	win.Frame.IconsField_Left.spacing = 5;
	win.Frame.IconsField_Left.preferredSize.width = 30;
	script.addColor( win.Frame.IconsField_Left, 0, iconsFieldColor );
	win.Frame.IconsField_Left.isIconsField = true;
	
	win.Frame.Grps = win.Frame.add('group');
	win.Frame.Grps.orientation = 'stack';
	win.Frame.Grps.alignment = ['fill', 'top'];
	win.Frame.Grps.margins = [3,3,3,3];
	win.Frame.Grps.spacing = 0;
	win.Frame.Grps.isItemsGroupsGroup = true;
	
	win.Frame.IconsField_Right = win.Frame.add('group');
	win.Frame.IconsField_Right.orientation = 'column';
	win.Frame.IconsField_Right.alignment = ['left', 'fill'];
	win.Frame.IconsField_Right.alignChildren = ['right', 'top'];
	win.Frame.IconsField_Right.margins = [5,3,3,3];
	win.Frame.IconsField_Right.spacing = 5;
	win.Frame.IconsField_Right.preferredSize.width = 30;
	script.addColor( win.Frame.IconsField_Right, 0, iconsFieldColor );
	win.Frame.IconsField_Right.isIconsField = true;
	
	win.IconsField_Bottom = win.add('group');
	win.IconsField_Bottom.orientation = 'row';
	win.IconsField_Bottom.alignment = ['fill', 'top'];
	win.IconsField_Bottom.alignChildren = ['left', 'top'];
	win.IconsField_Bottom.margins = [3,2,3,2];
	win.IconsField_Bottom.spacing = 5;
	win.IconsField_Bottom.preferredSize.height = 30;
	script.addColor( win.IconsField_Bottom, 0, iconsFieldColor );
	win.IconsField_Bottom.isIconsField = true;
	win.IconsField_Bottom.isIconsField_Bottom = true;
	
	if( OPTIONS.showOptionsButton )
		addOptionsButton( win );
	win.onClose = function(){
		saveProperties();
		closeApp = true;
		saveSets();
		}
	
	}catch(err){script.alertError(err)};
	}
function addOptionsButton( win ){
	if( win.Settings )
		return;
	win.Settings = win.add('iconbutton', undefined, undefined, {style: 'toolbutton'});
	win.Settings.preferredSize = [22,22];
	win.Settings.image = script.images.settings;
	win.Settings.onClick = getSettings;
	win.layout.layout(true);
	}
function removeOptionsButton( win ){
	if( !win.Settings )
		return;
	win.remove( win.Settings );
	win.Settings = false;
	win.layout.layout(true);
	}

function palette_ContextMenu(){
	script.messages.ru["New name"] = 'Новое имя';
	
	script.messages.ru["Add group"] = 'Добавить группу';
	script.messages.ru["Delete group"] = 'Удалить группу';
	script.messages.ru["Rename group"] = 'Имя группы';
	
	script.messages.ru["Add file"] = 'Добавить файл';
	script.messages.ru["Add folder"] = 'Добавить папку';
	
	script.messages.ru["Add list"] = 'Добавить список';
	script.messages.ru["Change list"] = 'Изменить список';
	
	script.messages.ru["Add icons group"] = 'Добавить группу иконок';
	
	script.messages.ru["Rename"] = 'Переименовать';
	script.messages.ru["Set icon"] = 'Назначить иконку';
	script.messages.ru["Relink"] = 'Сменить связь';
	script.messages.ru["Delete"] = 'Удалить';
	
	script.messages.ru["Open folder"] = 'Открыть папку';
	
	script.messages.ru["Cut"] = 'Вырезать';
	script.messages.ru["Copy"] = 'Копировать';
	script.messages.ru["Paste"] = 'Вставить';
	
	script.messages.ru["Cut all"] = 'Вырезать все';
	script.messages.ru["Copy all"] = 'Копировать все';
	
	script.messages.ru["Move up"] = 'Двигать вверх';
	script.messages.ru["Move down"] = 'Двигать вниз';
	
	script.messages.ru["Move left"] = 'Двигать влево';
	script.messages.ru["Move right"] = 'Двигать вправо';
	
	script.messages.ru["Save changes"] = 'Сохранить';
	script.messages.ru["Options"] = 'Настройки';
	
	script.messages.ru["Font style"] = 'Font style';
	
	script.messages.ru["Icons field"] = 'Поле иконок';
	script.messages.ru["left field"] = 'левое поле';
	script.messages.ru["right field"] = 'правое поле';
	script.messages.ru["top field"] = 'верхнее поле';
	script.messages.ru["bottom field"] = 'нижнее поле';
	
	script.messages.ru["Buttons width"] = 'Ширина кнопок';
	
	var contextMenuItems = [
		{ name: script.localize("Add group"), marker: "", action: function(){addGroup(true)}, visible: editGroupsAccess, enabled: true, notCloseMenu: false },
		{ name: script.localize("Delete group"), marker: "", action: deleteGroup, visible: editGroupsAccess, enabled: true, notCloseMenu: false },
		{ name: script.localize("Rename group"), marker: "", action: renameGroup, visible: editGroupsAccess, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: "", id: "",  action: false, visible: show_file_status, enabled: true, notCloseMenu: false },
		{ name: script.localize("Add file"), marker: "", action: addFsObject_Menu, visible: addItemAccess, enabled: true, notCloseMenu: false },
		{ name: script.localize("Add folder"), marker: "folder", action: addFsObject_Menu, visible: addItemAccess, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Add list"), marker: "Add list", action: addList_Menu, visible: addItemAccess, enabled: true, notCloseMenu: false },
		{ name: script.localize("Change list"), marker: "", action: changeList_Menu, visible: isList, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Add icons group"), marker: "Add icons group", action: addIconsGroup_Menu, visible: addItemAccess, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Rename"), marker: "", action: renameButton, visible: isButton, enabled: true, notCloseMenu: false },
		{ name: script.localize("Set icon"), marker: "", action: setIcon, visible: isIconButton, enabled: true, notCloseMenu: false },
		{ name: script.localize("Relink"), marker: "", action: relinkButton, visible: function(EVENT){return isButton(EVENT) || isIconButton(EVENT)}, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Copy all"), marker: "", action: copyAllItems, visible: copy_cut_all_access, enabled: true, notCloseMenu: false },
		{ name: script.localize("Cut all"), marker: "", action: cutAllItems, visible: copy_cut_all_access, enabled: true, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Delete"), marker: "", action: delItem, visible: isItem, enabled: true, notCloseMenu: false },
		{ name: script.localize("Copy"), marker: "", action: copyItem, visible: isItem, enabled: true, notCloseMenu: false },
		{ name: script.localize("Cut"), marker: "", action: cutItem, visible: isItem, enabled: true, notCloseMenu: false },
		{ name: script.localize("Paste"), marker: "", action: paste, visible: addItemAccess, enabled: function(EVENT){return win.BUFFER ? true : false}, notCloseMenu: false },
		script.separatorMenuItem,
		{ name: script.localize("Move up"), marker: -1, action: swapItems, visible: visible_move_menuItem, enabled: true, notCloseMenu: true },
		{ name: script.localize("Move down"), marker: 1, action: swapItems, visible: visible_move_menuItem, enabled: true, notCloseMenu: true },
		{ name: script.localize("Move left"), marker: -1, action: swapItems, visible: visible_move_menuItem, enabled: true, notCloseMenu: true },
		{ name: script.localize("Move right"), marker: 1, action: swapItems, visible: visible_move_menuItem, enabled: true, notCloseMenu: true },
		script.separatorMenuItem,
		{ name: script.localize("Font style"), marker: "", action: setFont, visible: font_style, enabled: true, notCloseMenu: true },
//			{ name: script.localize("Font color"), action: setColor, visible: isButton, enabled: true, notCloseMenu: true }, // смена цвета и фона текста кнопок недоступна
		script.separatorMenuItem,
		{ name: script.localize("Save changes"), marker: "", action: function(){saveSets( true )}, visible: true, enabled: function(EVENT){return CHANGES.status}, notCloseMenu: false },
		{ name: script.localize("Options"), marker: "", action: getSettings, visible: true, enabled: true, notCloseMenu: false },
		];
	script.addContextMenu( { target: win, menuItems: contextMenuItems, palette: true, preAction: preAction } );
	function preAction(EVENT){
		if( EVENT.target.isTab )
			selectGroup( script.getUiObjectIndex(EVENT.target) );
		return true ;
		}
	// работа с элементами группы
	function isItem( EVENT, menuItem ){
		return EVENT.target.isItem; // button | dropdownlist | iconButton | iconsGroup
		}
	function isButton( EVENT, menuItem ){ return EVENT.target.isItem && EVENT.target.type == 'button' }
	function isIconButton( EVENT, menuItem ){ return EVENT.target.isItem && EVENT.target.type == 'iconbutton' }
	function isIconButtonOrIconsFieldOrIconsGroup( EVENT, menuItem ){ return isIconButton(EVENT) || EVENT.target.isIconsField || EVENT.target.isIconsGroup }
	function isItemOrItemsArea( EVENT, menuItem ){ return isItem( EVENT ) || EVENT.target.isItemsGroup || EVENT.target.isItemsGroupsGroup }
	function addItemAccess( EVENT, menuItem ){
//		if( !(isItemOrItemsArea(EVENT) || editGroupsAccess(EVENT)) || getCurrentGroupIndex() == null )
//			return false;
		if( !(isItem(EVENT) || editGroupsAccess(EVENT) || EVENT.target.isIconsField || EVENT.target.isItemsGroup) )
			return false;
		
		if( menuItem.marker == "Add list" && (EVENT.target.isIconsField || EVENT.target.parent.isIconsField || EVENT.target.parent.isItemsGroup) )
			return false;
		if( menuItem.marker == "Add icons group" && (EVENT.target.isIconsField || EVENT.target.parent.isIconsField) )
			return false;
		return true;
		}
	function copy_cut_all_access( EVENT, menuItem ){
		if( !isItemOrItemsArea(EVENT) && !isIconButtonOrIconsFieldOrIconsGroup(EVENT) )
			return false;
		if( isIconButton(EVENT) )
			return EVENT.target.parent.children.length;
		else if( EVENT.target.isIconsField || EVENT.target.isIconsGroup )
			return EVENT.target.children.length;
		else
			return getCurrentGroup().children.length;
		}
	function visible_move_menuItem( EVENT, menuItem ){
		if( !isItem(EVENT) )
			return false;
		if( EVENT.target.parent.isIconsGroup || EVENT.target.parent.isIconsField_Top || EVENT.target.parent.isIconsField_Bottom ){
			if( menuItem.name == script.localize("Move up") || menuItem.name == script.localize("Move down") )
				return false;
			}
		else if( menuItem.name == script.localize("Move left") || menuItem.name == script.localize("Move right") )
			return false;
		return true;
		}
	// работа с группами
	function editGroupsAccess( EVENT ){ return EVENT.view.isTab || EVENT.view.isTabsGroup } // UI-объект Group не имеет properties, поэтому идентифицируем по-другому
	
	function show_file_status( EVENT ){
		if( EVENT.target.type == 'button' ){
			var fsObject = getFsObject( EVENT.target.helpTip );
			if( fsObject.exists )
				return false;
			this.name = fsObject.constructor.name + " not exists";
			this.textRGB = [123,0,0];
			return true;
			}
		if( EVENT.target.type == 'dropdownlist' && EVENT.target.parent._list.autoFillFromFolder ){
			var fsObject = getFsObject( EVENT.target.parent._list.adaptFsNames[0] );
			if( fsObject.exists )
				return false;
			this.name = fsObject.constructor.name + " not exists";
			this.textRGB = [123,0,0];
			return true;
			}
		return false;
		}
	// ================ BUTTON ====================================
	function renameButton( EVENT ){
		var BUTTON =  EVENT.view;
		var name = prompt( script.localize('New name')+':', BUTTON.text, script.name );
		if( name ){
			BUTTON.text = name;
			CHANGES.setStatus();
			}
		}
	function relinkButton( EVENT ){
		var BUTTON =  EVENT.target;
		var thisFsObject = getFsObject(BUTTON.helpTip);
		var type = thisFsObject.constructor.name;
		// определяем ближайшую существующую родительскую папку
		while( true ){
			try{ thisFsObject = thisFsObject.parent; }catch(err){ thisFsObject = undefined; break; }
			if( thisFsObject.exists ) break;
			}
		if( type == 'Folder' )
			var myF = Folder.selectDialog( "Add folder", thisFsObject );
		else
			var myF = thisFsObject ? thisFsObject.openDlg("Add file") : File.openDialog("Add file");
		if(!myF)
			return;
		BUTTON.helpTip = getAdaptFsName( myF );
		CHANGES.setStatus();
		}
	function swapItems( EVENT, listItem ){
		var next = listItem.menuItem.marker; // next = 1/-1
		try{
		if( isIconButton(EVENT) ){
			var iconButton = EVENT.target;
			var iconButtonIndex = script.getUiObjectIndex( iconButton );
			var next_index = iconButtonIndex + next;
			if( (next == -1 && next_index < 0) || (next == 1 && next_index == iconButton.parent.children.length) )
				return;
			var next_iconButton = iconButton.parent.children[next_index];
			//get data
			var itemData = getIconButtonData( iconButton );
			var next_itemData = getIconButtonData( next_iconButton );
			//swap
			addIcon( { iconButton: iconButton, iconPath: next_itemData.iconPath, text: 'Q', helpTip: next_itemData.adaptFsNames[0] } );
			addIcon( { iconButton: next_iconButton, iconPath: itemData.iconPath, text: 'Q', helpTip: itemData.adaptFsNames[0] } );
			
			EVENT.target = EVENT.view = next_iconButton;
			}
		else{
			var GROUP_ITEM = EVENT.target.parent;
			var groupItemIndex = script.getUiObjectIndex( GROUP_ITEM );
			var next_index = groupItemIndex + next;
			if( (next == -1 && next_index < 0) || (next == 1 && next_index == GROUP_ITEM.parent.children.length) )
				return;
			var NEXT_GROUP_ITEM = GROUP_ITEM.parent.children[next_index];
			//get data
			var itemData = getGroupItemData( GROUP_ITEM );
			var next_itemData = getGroupItemData( NEXT_GROUP_ITEM );
			
			//swap
			if( addItem(GROUP_ITEM, next_itemData) )
				addItem( NEXT_GROUP_ITEM, itemData, true );
			
			EVENT.target = EVENT.view = NEXT_GROUP_ITEM._current;
			}
		
		CHANGES.setStatus();
		}catch(err){script.alertError(err)};
		}
	function addFsObject_Menu(EVENT, listItem){
		var folder = listItem.menuItem.marker == "folder";
		try{
		var thisFsObject = undefined;
		if(EVENT.view.type == 'button' || EVENT.view.type == 'iconbutton'){
			thisFsObject = getFsObject(EVENT.view.helpTip);
			}
		var myF = (!folder) ? File.openDialog("Add file") : Folder.selectDialog( "Add folder", thisFsObject );
		if(!myF)
			return;
		var name = script.getFileName(myF).substr(0, 10);
		if( isIconButtonOrIconsFieldOrIconsGroup(EVENT) ){
			var iconsContainer = (EVENT.target.isIconsField || EVENT.target.isIconsGroup) ? EVENT.target : EVENT.target.parent;
			addIconButton( iconsContainer, {type: 'iconbutton', name: name, adaptFsNames: [getAdaptFsName(myF)]}, true );
			}
		else
			addGroupItem( getCurrentGroup(), {type: 'button', name: name, adaptFsNames: [getAdaptFsName(myF)]}, true );
		CHANGES.setStatus();
		}catch(err){script.alertError(err)};
		}
	function delItem( EVENT ){
		try{
		if( isIconButton(EVENT) )
			EVENT.view.parent.remove(EVENT.view);
		else
			EVENT.view.parent.parent.remove(EVENT.view.parent);
		win.layout.layout(true);
		CHANGES.setStatus();
		}catch(err){script.alertError(err)};
		}
	// ================ IconsGroup ==============================
	function addIconsGroup_Menu( EVENT ){ // return new itemData or undefined
	//	if( EVENT.target.isIconsGroup || EVENT.target.parent.isIconsGroup )
	//		return;
		addGroupItem( getCurrentGroup(), {type: 'iconsgroup'}, true );
		CHANGES.setStatus();
		}
	// ================ LIST ==============================
	function isList( EVENT, menuItem ){ // return new itemData or undefined
		return EVENT.view.type == 'dropdownlist';
		}
	function addList_Menu( EVENT ){ // return new itemData or undefined
//		if( (isIconButton(EVENT) && EVENT.target.parent.isIconsField) || EVENT.target.isIconsField )
//			return;
		var new_itemData = listRedactor();
		if( !new_itemData )
			return;
		addGroupItem( getCurrentGroup(), new_itemData, true );
		CHANGES.setStatus();
		}
	function changeList_Menu( EVENT ){
		// сбрасываем фокус, иначе обновление списка через focus не отработает
		EVENT.view.active = false;
		
		var new_itemData = listRedactor( getGroupItemData(EVENT.view.parent) );
		if( !new_itemData )
			return;
		addList( EVENT.view.parent, new_itemData, true );
		CHANGES.setStatus();
		}
	function listRedactor( itemData ){ // return new itemData or undefined
		try{
		var result_itemData;
		
		var win = new Window( 'dialog', 'List redactor' );
		win.alignChildren = ['left', 'top'];
		win.preferredSize.width = 600;
		win.margins = 5;
		win.spacing = 5;
		with( win ){
			win.title = add( 'group' );
			win.title.alignment = ['center', 'top'];
			with( win.title ){
				add( 'statictext', undefined, 'Title:' );
				win.title.Value = add( 'edittext' );
				win.title.Value.preferredSize.width = 200;
				}
			
			win.autoList = add( 'checkbox', undefined, 'Auto fill list from folder:' );
			win.folder = add( 'group' );
			win.folder.margins = [20,0,0,0];
			win.folder.alignment = ['fill', 'top'];
			win.folder.alignChildren = ['left', 'top'];
			with(win.folder){
				win.folder.select = add( "button", undefined, 'Select folder' );
				win.folder.path = add( "edittext", undefined, undefined, {readonly: true} );
				win.folder.path.alignment = ['fill', 'top'];
				}
			add( 'statictext' ); // распорка
			}
		
		var redactor = win.add( 'group' );
		redactor.alignment = ['fill', 'top'];
		redactor.alignChildren = ['left', 'top'];
		redactor.orientation = 'row';
		redactor.spacing = 5;
		
		with( redactor ){
			var butts = add( 'group' );
			butts.orientation = 'column';
			with(butts){
				butts.addRow = add( "iconbutton", undefined, undefined, {style: "toolbutton"} );
				butts.addRow.preferredSize = [20,20];
		//		butts.addRow.title = "+";
		//		butts.addRow.helpTip = "Add item";
				butts.up = add( "iconbutton", undefined, undefined, {name: -1, style: "toolbutton"} );
				butts.up.preferredSize = [20,20];
		//		butts.up.title = "^";
		//		butts.up.helpTip = "Move up";
				butts.down = add( "iconbutton", undefined, undefined, {name: 1, style: "toolbutton"} );
				butts.down.preferredSize = [20,20];
		//		butts.down.title = "V";
		//		butts.down.helpTip = "Move down";
				butts.deleteRow = add( "iconbutton", undefined, undefined, {style: "toolbutton"} );
				butts.deleteRow.preferredSize = [20,20];
		//		butts.deleteRow.title = "X";
		//		butts.deleteRow.helpTip = "Delete item";
				}
			redactor.listBox = add( "listbox", undefined, undefined );
			redactor.listBox.alignment = ['fill', 'top'];
			redactor.listBox.preferredSize.height = 200;
			}
		
		addIcon( { iconButton: butts.addRow, iconPath: "Layout/(Book Panel Resources)/idrc_PNGA/1522.idrc", text: '+', helpTip: 'Add item' } );
		addIcon( { iconButton: butts.up, iconPath: "Text/(RunIn Styles Panel Resources)/idrc_PNGA/100.idrc", text: '^', helpTip: 'Move up' } );
		addIcon( { iconButton: butts.down, iconPath: "Text/(RunIn Styles Panel Resources)/idrc_PNGA/200.idrc", text: 'V', helpTip: 'Move down' } );
		addIcon( { iconButton: butts.deleteRow, iconPath: "Text/(Find and Change Panel Resources)/idrc_PNGA/118.idrc", text: 'X', helpTip: 'Delete item' } ); // 
		
		var ok_cancel = win.add( 'group' );
		ok_cancel.alignment = ['right', 'top'];
		ok_cancel.orientation = 'row';
		with( ok_cancel ){
			ok_cancel.cancel = add( 'button', undefined, 'Cancel' );
			ok_cancel.ok = add( 'button', undefined, 'Ok' );
			}
		
		win.autoList.onClick = function(){
			if( this.value && !win.folder.path.text ){
				this.value = false;
				alert( 'Select folder' );
				}
			if( this.value ){
		//		if( redactor.listBox.items.length && !confirm('Current list items will be deleted. Continue?') )
		//			return;
		//		redactor.listBox.removeAll(); // Illustrator Windows вылетет, поэтому удаляем поштучно
				while( redactor.listBox.items.length )
					redactor.listBox.remove( redactor.listBox.items[0] );
				var folder = getFsObject( win.folder.path.text );
				if( !folder.exists ){
					this.value = false;
					return alert( 'folder not exists: ' + win.folder.path.text );
					}
				var files = folder.getFiles( function(f){ return f instanceof File && regExpFileFilterForAutoList.test(f.fsName) ? true : false } );
				for( var i = 0; i < files.length; i++ )
					addItemToList( files[i] );
				
				if( !win.title.Value.ext )
					win.title.Value.text = script.getFileName( folder );
				}
			
			butts.visible = !this.value;
			}
		win.folder.select.onClick = function(){
			var current_folder = win.folder.path.text ? getFsObject( win.folder.path.text ) : undefined;
			if( current_folder && !current_folder.exists )
				current_folder = undefined;
			if( !current_folder && OPTIONS.relativeLinks )
				current_folder = script.file.parent;
			var folder = current_folder ? current_folder.selectDlg( 'Select folder' ) : Folder.selectDialog( 'Select folder' );
			if( folder ){
				win.folder.path.text = getAdaptFsName( folder );
				if( win.autoList.value )
					win.autoList.onClick();
				}
			}
		
		function addItemToList( fileOrPath ){ // return item
			 // 
			var adaptFsName = fileOrPath instanceof File ? getAdaptFsName( fileOrPath ) : fileOrPath;
			var item = redactor.listBox.add( 'item', adaptFsName );
			item.adaptFsName = adaptFsName;
			return item;
			}
		
		butts.addRow.onClick = function(){
			var files = File.openDialog( "Select files", undefined, true ); // multiselect. Return [] or null
			if( !files )
				return;
			for( var i = 0; i < files.length-1; i++ )
				addItemToList( files[i] );
			// последний выделяем
			redactor.listBox.selection = addItemToList( files[files.length-1] );
			}
		butts.up.onClick = butts.down.onClick = function(){
			try{
			var listBox = redactor.listBox;
			if(listBox.selection == null || listBox.items.length < 1 )
				return;
			if(this.properties.name == -1 && listBox.selection.index == 0)
				return;
			if(this.properties.name == 1 && listBox.selection.index == listBox.items.length-1)
				return;
			var item = listBox.selection;
			var nextItem = listBox.items[listBox.selection.index + this.properties.name];
			
			var _adaptFsName = item.text;
			
			item.text = nextItem.text;
			nextItem.text = _adaptFsName;
			
			listBox.selection = nextItem;
			}catch(err){script.alertError(err);}
			}
		butts.deleteRow.onClick = function(){
			if( !redactor.listBox.selection )
				return;
			var item = redactor.listBox.selection;
			var next_item_index = item.index ? item.index-1 : (redactor.listBox.items.length > 1 ? item.index : null );
			redactor.listBox.remove( item );
			if( next_item_index !== null )
				redactor.listBox.selection = next_item_index;
			}
		
		ok_cancel.ok.onClick = function(){
			result_itemData = {
				type: 'dropdownlist',
				name: win.title.Value.text,
				};
			if( win.autoList.value ){
				result_itemData.autoFillFromFolder = true;
				result_itemData.adaptFsNames = [win.folder.path.text];
				}
			else{
				result_itemData.adaptFsNames = [];
				for( var i = 0; i < redactor.listBox.items.length; i++ )
					result_itemData.adaptFsNames.push( redactor.listBox.items[i].text );
				}
			if( itemData && itemData.toSource() == result_itemData.toSource() )
				result_itemData = undefined;
			this.window.close();
			}
		
		// INI
		if( itemData ){
			win.title.Value.text = itemData.name || '';
			if( itemData.autoFillFromFolder ){
				win.folder.path.text = itemData.adaptFsNames[0];
				win.autoList.value = true;
				win.autoList.onClick();
				}
			else{
				for( var i = 0; i < itemData.adaptFsNames.length; i++ )
					addItemToList( itemData.adaptFsNames[i] );
				}
			}
		
		win.center();
		win.show();
		
		return result_itemData;
		}catch(err){script.alertError(err)};
		}
	//================ CUT / COPY / PASTE ==========================
	function copyItem( EVENT ){
		if( isIconButton(EVENT) )
			win.BUFFER = getIconButtonData( EVENT.view );
		else
			win.BUFFER = getGroupItemData( EVENT.view.parent );
		}
	function cutItem( EVENT ){
		copyItem( EVENT );
		delItem( EVENT );
		}
	function paste( EVENT ){
		if( !win.BUFFER )
			return;
		
		var group;
		if( isIconButtonOrIconsFieldOrIconsGroup(EVENT) )
			group = (EVENT.target.parent.isIconsField || EVENT.target.parent.isIconsGroup) ? EVENT.target.parent : EVENT.target;
		else
			group = getCurrentGroup();
		
		if( win.BUFFER.constructor == Array )
			for( var i = 0; i < win.BUFFER.length; i++ )
				addGroupItem( group, win.BUFFER[i], true );
		else
			addGroupItem( group, win.BUFFER, true );
		
		CHANGES.setStatus();
		}
	
	function copyAllItems( EVENT ){
		win.BUFFER = [];
		var items;
		if( isIconButtonOrIconsFieldOrIconsGroup(EVENT) ){
			items = (EVENT.target.parent.isIconsField || EVENT.target.parent.isIconsGroup) ? EVENT.target.parent.children : EVENT.target.children;
			for( var i = 0; i < items.length; i++ )
				win.BUFFER[i] = getGroupItemData( items[i] );
			}
		else{
			items = getCurrentGroup().children;
			for( var i = 0; i < items.length; i++ )
				win.BUFFER[i] = getGroupItemData( items[i] );
			}
		}
	function cutAllItems( EVENT ){
		try{
		copyAllItems( EVENT );
		var group;
		if( isIconButtonOrIconsFieldOrIconsGroup(EVENT) )
			group = (EVENT.target.parent.isIconsField || EVENT.target.parent.isIconsGroup) ? EVENT.target.parent : EVENT.target;
		else
			group = getCurrentGroup();
		for( var i = group.children.length-1; i > -1; i-- )
			group.remove(group.children[i]);
		win.layout.layout(true);
		CHANGES.setStatus();
		}catch(err){script.alertError(err)};
		}
	// ==============  FONT / COLOR =====================================
	function font_style( EVENT ){
		if( !isButton(EVENT) )
			return;
		// Font style
		var font = script.addFont( EVENT.view );
		this.name = script.localize("Font style") + ': ' + ( font && font.style ? font.style : 'Regular' );
		return true;
		}
	/*
	function setColor( EVENT ){
		// смена цвета и фона текста кнопок недоступна
		return;
		var RGB = script.getColorPicker( script.getRGB(EVENT.view, 'foregroundColor')  );
		if( RGB ){
			var res = script.addColor( EVENT.view, 'foregroundColor', RGB );
			alert( script.getRGB( res.color ) );
			}
		}
	*/
	function setFont( EVENT, listItem ){
		var nextStyles = {
			'Regular': 'Bold', 
			'Bold': 'Italic', 
			'Italic': 'Bolditalic', 
			'Bolditalic': 'Regular'
			}
		var font = script.addFont( EVENT.view );
		var style = ( font && font.style ? font.style : 'Regular' );
		var newStyle = nextStyles[style];
		var count = 0;
		while( true ){
			var newFont = script.addFont( EVENT.view, {style: newStyle} );
			if( newFont && newFont.style != style ){
				newStyle = newFont.style;
				CHANGES.setStatus();
				break;
				}
			else
				newStyle = nextStyles[newStyle];
			if( ++count > 5 ){
				newStyle = null;
				break;
				}
			}
		// view on context menu
		if( listItem && newStyle !== null ){
			listItem.menuItem.name = script.localize("Font style") + ': ' + (newStyle ? newStyle : 'Regular');
			listItem.CM.refreshItem( listItem );
			}
		}
	// ==============  GROUP =====================================
	function getCurrentGroup(){
		return win.Frame.Grps.children[getCurrentGroupIndex()];
		}
	function getCurrentGroupIndex(){
		for( var i = 0; i < win.Tabs.children.length; i++ )
			if( !win.Tabs.children[i].enabled )
				return i;
		return null;
		}
	function deleteGroup( EVENT ){
		try{
		var INDEX = getCurrentGroupIndex();
		if(win.Frame.Grps.children[INDEX].children.length){
			var very = confirm('This group contains buttons. Delete the group?');
			if(!very)
				return;
			}
		win.Tabs.remove(win.Tabs.children[INDEX]);
		win.Frame.Grps.remove(win.Frame.Grps.children[INDEX]);
		win.layout.layout(true);
		selectGroup( (INDEX) ? INDEX-1 : 0 );
		CHANGES.setStatus();
		}catch(err){script.alertError(err)};
		}
	function renameGroup( EVENT ){
		try{
		var BUTTON = win.Tabs.children[ getCurrentGroupIndex()];
		var name = prompt( script.localize('New name')+':', BUTTON.title, script.name );
		if( name ){
			BUTTON.title = name;
			CHANGES.setStatus();
			}
		}catch(err){script.alertError(err)};
		}
	}
//================ SETTINGS ===============================
function getSettings(){
	try{
	var isAI = script.getAppName( 'illustrator' );
	
	var winSettings = new Window("dialog", script.localize('Options'), );
	winSettings.preferredSize = [200,50];
	winSettings.alignChildren = ['left', 'top'];
	winSettings.margins = 5;
	winSettings.spacing = 10;
	with(winSettings){
		winSettings.Orientation = add( "group", undefined, undefined );
		with(winSettings.Orientation){
			winSettings.Orientation.column = add( "radiobutton", undefined, 'column' );
			winSettings.Orientation.row = add( "radiobutton", undefined, 'row' );
			}
		winSettings.showOptionsButton = add( "group" );
		winSettings.showOptionsButton.orientation = "row";
		with(winSettings.showOptionsButton){
			winSettings.showOptionsButton.Value = add( "checkbox", undefined, script.localize("show button") );
			add( "image", undefined, script.images.settings );
			}
		
		
		winSettings.IconsField = add( "panel", undefined, script.localize('Icons field') );
		winSettings.IconsField.orientation = "column";
		winSettings.IconsField.alignment = "fill";
		winSettings.IconsField.alignChildren = ["left","top"];
		winSettings.IconsField.margins = [5,15,5,5];
		with(winSettings.IconsField){
			// Left Field
			winSettings.IconsField.Left = add( "group" );
			winSettings.IconsField.Left.orientation = "row";
			with(winSettings.IconsField.Left){
				winSettings.IconsField.Left.Show = add( "checkbox", undefined, script.localize('left field'), {name: 'left'} );
				winSettings.IconsField.Left.Alignment = add( "group" );
				winSettings.IconsField.Left.Alignment.orientation = "row";
				with(winSettings.IconsField.Left.Alignment ){
					add( 'statictext', undefined, 'alignment: ' ).alignment = ["left","fill"];
					winSettings.IconsField.Left.Alignment.top = add( "radiobutton", undefined, 'top' );
					winSettings.IconsField.Left.Alignment.center = add( "radiobutton", undefined, 'center' );
					winSettings.IconsField.Left.Alignment.bottom = add( "radiobutton", undefined, 'bottom' );
					}
				}
			// Right Field
			winSettings.IconsField.Right = add( "group" );
			winSettings.IconsField.Right.orientation = "row";
			with(winSettings.IconsField.Right){
				winSettings.IconsField.Right.Show = add( "checkbox", undefined, script.localize('right field'), {name: 'right'} );
				winSettings.IconsField.Right.Alignment = add( "group" );
				winSettings.IconsField.Right.Alignment.orientation = "row";
				with(winSettings.IconsField.Right.Alignment ){
					add( 'statictext', undefined, 'alignment: ' ).alignment = ["left","fill"];
					winSettings.IconsField.Right.Alignment.top = add( "radiobutton", undefined, 'top' );
					winSettings.IconsField.Right.Alignment.center = add( "radiobutton", undefined, 'center' );
					winSettings.IconsField.Right.Alignment.bottom = add( "radiobutton", undefined, 'bottom' );
					}
				}
			// Top Field
			winSettings.IconsField.Top = add( "group" );
			winSettings.IconsField.Top.orientation = "row";
			with(winSettings.IconsField.Top){
				winSettings.IconsField.Top.Show = add( "checkbox", undefined, script.localize('top field'), {name: 'top'} );
				winSettings.IconsField.Top.Alignment = add( "group" );
				winSettings.IconsField.Top.Alignment.orientation = "row";
				with(winSettings.IconsField.Top.Alignment ){
					add( 'statictext', undefined, 'alignment: ' ).alignment = ["left","fill"];
					winSettings.IconsField.Top.Alignment.left = add( "radiobutton", undefined, 'left' );
					winSettings.IconsField.Top.Alignment.center = add( "radiobutton", undefined, 'center' );
					winSettings.IconsField.Top.Alignment.right = add( "radiobutton", undefined, 'right' );
					}
				}
			// Bottom Field
			winSettings.IconsField.Bottom = add( "group" );
			winSettings.IconsField.Bottom.orientation = "row";
			with(winSettings.IconsField.Bottom){
				winSettings.IconsField.Bottom.Show = add( "checkbox", undefined, script.localize('bottom field'), {name: 'bottom'} );
				winSettings.IconsField.Bottom.Alignment = add( "group" );
				winSettings.IconsField.Bottom.Alignment.orientation = "row";
				with(winSettings.IconsField.Bottom.Alignment ){
					add( 'statictext', undefined, 'alignment: ' ).alignment = ["left","fill"];
					winSettings.IconsField.Bottom.Alignment.left = add( "radiobutton", undefined, 'left' );
					winSettings.IconsField.Bottom.Alignment.center = add( "radiobutton", undefined, 'center' );
					winSettings.IconsField.Bottom.Alignment.right = add( "radiobutton", undefined, 'right' );
					}
				}
			}
		
		winSettings.buttonsWidth = add( "group" );
		winSettings.autoStart = add( "checkbox", undefined, script.localize('autostart') );
		winSettings.autoSave = add( "checkbox", undefined, script.localize('autosave changes') );
		winSettings.relativeLinks = add( "checkbox", undefined, script.localize('use relative links') );
		if( File.fs == 'Windows' && !isAI )
			winSettings.debugFocus = add( "checkbox", undefined, script.localize('toggle keyboard focus in Control Panel after execute') );
		
		if( isAI ){
			winSettings.AI_Metods = add( "panel", undefined, undefined );
			winSettings.AI_Metods.sText = winSettings.AI_Metods.add( "statictext", undefined, 'Methods of running of scripts for AI (.js/.jsx)' );
			winSettings.AI_Metods.orientation = 'column';
			winSettings.AI_Metods.alignChildren = ['left', 'top'];
			}
		
		winSettings.buts = add( "group", undefined, undefined );
		winSettings.buts.alignment = ['right', 'top'];
		with(winSettings.buts){
			winSettings.buts.info = add( "button", undefined, 'Info' );
			winSettings.buts.Close = add( "button", undefined, 'Close' );
			}
		}
	
	if( isAI ){	
		for( var m in runAIMetods ){
			winSettings.AI_Metods[m] = winSettings.AI_Metods.add("checkbox", undefined, m);
			if( !isAI || runAIMetods[m].supportCS > thisCS )
				winSettings.AI_Metods[m].enabled = false;
			else{
				winSettings.AI_Metods[m].value = OPTIONS.activeMethods[m];
				winSettings.AI_Metods[m].onClick = function(){ OPTIONS.activeMethods[this.text] = this.value }
				if( runAIMetods[m].note )
					winSettings.AI_Metods[m].helpTip = runAIMetods[m].note;
				}
			}
		}
	
	var buttonsWidth_numberField = getUINumberField( {
		currentValue: ( win.Frame.Grps.children[0].children.length ? win.Frame.Grps.children[0].children[0].minimumSize.width : OPTIONS.buttonsWidth ), // Number. Default: 0
		maxValue: 500, // Number. Default: Number.POSITIVE_INFINITY
		minValue: 10, // Number. Default: Number.NEGATIVE_INFINITY
		emptyValue: false, // Bool. Default: false. Может ли поле принимать пустое значение
		callback: function( oldNum, newNum ){
			try{
			OPTIONS.buttonsWidth = newNum;
			for(var i = 0; i < win.Frame.Grps.children.length; i++){
				for(var z = 0; z < win.Frame.Grps.children[i].children.length; z++){
//					win.Frame.Grps.children[i].children[z].preferredSize.width = OPTIONS.buttonsWidth;
					win.Frame.Grps.children[i].children[z].minimumSize.width = win.Frame.Grps.children[i].children[z].maximumSize.width = OPTIONS.buttonsWidth;
					}
				}
			win.layout.layout( true );
			CHANGES.setStatus();
			}catch(err){ script.alertError( err ) }
			}, // Function. Default: function( oldNum, newNum ){ return newNum }
		
		uiField: undefined, // EditText object. Если указан этот параметр - нижеследующие параметры не учитываются
		
		uiContainer: winSettings.buttonsWidth, // UI-object: Window, Panel, Group or Tab
		buttons: true, // Bool. Default: false
		step: 10, // Number. Default: 1
		secondButtons: false, // Bool. Default: false
		secondStep: 0.1, // Number. Default: 0.1
		prefix: script.localize("Buttons width"), // String
		postfix: '', // String
		readOnly: false, // Bool. Default: false
		} );
	
	//=========================================================

	if(script.file.parent.fsName == script.getStartupFolder().fsName){
		winSettings.autoStart.value = true;
		winSettings.autoStart.enabled = false;
		}
	else if( !isAI )
		winSettings.autoStart.value = script.getFileAlias(script.getStartupFolder(), script.file);
	winSettings.showOptionsButton.Value.value = OPTIONS.showOptionsButton;
	// Left Field
	winSettings.IconsField.Left.Show.value = winSettings.IconsField.Left.Alignment.enabled = visibleIconsField( {iconsField: win.Frame.IconsField_Left, value: undefined, layout: false} ); // value: true|false|undefined. Return Bool
	var _alignment = alignmentIconsField( {iconsField: win.Frame.IconsField_Left, value: undefined, layout: false} );
	winSettings.IconsField.Left.Alignment[_alignment].value = true;
	// Right Field
	winSettings.IconsField.Right.Show.value = winSettings.IconsField.Right.Alignment.enabled = visibleIconsField( {iconsField: win.Frame.IconsField_Right, value: undefined, layout: false} ); // value: true|false|undefined. Return Bool
	var _alignment = alignmentIconsField( {iconsField: win.Frame.IconsField_Right, value: undefined, layout: false} );
	winSettings.IconsField.Right.Alignment[_alignment].value = true;
	// Top Field
	winSettings.IconsField.Top.Show.value = winSettings.IconsField.Top.Alignment.enabled = visibleIconsField( {iconsField: win.IconsField_Top, value: undefined, layout: false} ); // value: true|false|undefined. Return Bool
	var _alignment = alignmentIconsField( {iconsField: win.IconsField_Top, value: undefined, layout: false} );
	winSettings.IconsField.Top.Alignment[_alignment].value = true;
	// Bottom Field
	winSettings.IconsField.Bottom.Show.value = winSettings.IconsField.Bottom.Alignment.enabled = visibleIconsField( {iconsField: win.IconsField_Bottom, value: undefined, layout: false} ); // value: true|false|undefined. Return Bool
	var _alignment = alignmentIconsField( {iconsField: win.IconsField_Bottom, value: undefined, layout: false} );
	winSettings.IconsField.Bottom.Alignment[_alignment].value = true;
	
	
	
	winSettings.autoSave.value = OPTIONS.autoSave;
	winSettings.relativeLinks.value = OPTIONS.relativeLinks;
	if( File.fs == 'Windows' && !isAI )
		winSettings.debugFocus.value = OPTIONS.debugFocus;
	
	(win.orientation == 'column') ? (winSettings.Orientation.column.value = true) : (winSettings.Orientation.row.value = true);
	
	winSettings.Orientation.column.onClick = winSettings.Orientation.row.onClick = function(){
		paletteOrientation(this.text);
		}
	winSettings.showOptionsButton.Value.onClick = function(){
		if( this.value )
			addOptionsButton( win );
		else
			removeOptionsButton( win );
		OPTIONS.showOptionsButton = this.value;
		CHANGES.setStatus();
		}
	winSettings.IconsField.Left.Show.onClick = 
	winSettings.IconsField.Right.Show.onClick = 
	winSettings.IconsField.Top.Show.onClick = 
	winSettings.IconsField.Bottom.Show.onClick = function(){
		var iconsField;
		switch( this.properties.name ){
			case 'left':
				iconsField = win.Frame.IconsField_Left;
			break;
			case 'right':
				iconsField = win.Frame.IconsField_Right;
			break;
			case 'top':
				iconsField = win.IconsField_Top;
			break;
			case 'bottom':
				iconsField = win.IconsField_Bottom;
			break;
			}
		visibleIconsField( {iconsField: iconsField, value: this.value, layout: true} ); // value: true|false|undefined. Return Bool
		this.parent.Alignment.enabled = this.value;
		}
	winSettings.IconsField.Left.Alignment.top.onClick =
	winSettings.IconsField.Left.Alignment.center.onClick =
	winSettings.IconsField.Left.Alignment.bottom.onClick = 
	
	winSettings.IconsField.Right.Alignment.top.onClick =
	winSettings.IconsField.Right.Alignment.center.onClick =
	winSettings.IconsField.Right.Alignment.bottom.onClick = 
	
	winSettings.IconsField.Top.Alignment.left.onClick =
	winSettings.IconsField.Top.Alignment.center.onClick =
	winSettings.IconsField.Top.Alignment.right.onClick = 
	
	winSettings.IconsField.Bottom.Alignment.left.onClick = 
	winSettings.IconsField.Bottom.Alignment.center.onClick = 
	winSettings.IconsField.Bottom.Alignment.right.onClick = function(){
		var iconsField;
		switch( this.parent.parent.Show.properties.name ){
			case 'left':
				iconsField = win.Frame.IconsField_Left;
			break;
			case 'right':
				iconsField = win.Frame.IconsField_Right;
			break;
			case 'top':
				iconsField = win.IconsField_Top;
			break;
			case 'bottom':
				iconsField = win.IconsField_Bottom;
			break;
			}
		alignmentIconsField( {iconsField: iconsField, value: this.text, layout: true} );
		}
	winSettings.relativeLinks.onClick = function(){
		OPTIONS.relativeLinks = this.value;
		// обновляем значение helpTip всех кнопок 
		// iconButtons
		var iconButtons = win.Frame.IconsField_Left.children;
		for( var z = 0; z < iconButtons.length; z++ )
			iconButtons[z].helpTip = getAdaptFsName( getFsObject(iconButtons[z].helpTip) );
			
		var iconButtons = win.Frame.IconsField_Right.children;
		for( var z = 0; z < iconButtons.length; z++ )
			iconButtons[z].helpTip = getAdaptFsName( getFsObject(iconButtons[z].helpTip) );
			
		// groups
		var groups = win.Frame.Grps.children;
		var item;
		for(var i = 0; i < groups.length; i++){
			for(var j = 0; j < groups[i].children.length; j++){
				item = groups[i].children[j]._current;
				switch( item.type ){
					case 'button':
						item.helpTip = getAdaptFsName( getFsObject(item.helpTip) );
						break;
					case 'dropdownlist':
						if( item.autoFillFromFolder )
							item.helpTip = getAdaptFsName( getFsObject(item.helpTip) );
						else{
							for( var z = 0; z < item.adaptFsNames.length; z++ )
								item.adaptFsNames[z] = getAdaptFsName( getFsObject(item.adaptFsNames[z]) );
							}
						break;
					
					}
				}
			}
		CHANGES.setStatus();
		this.window.listBox.notify();
		}
	winSettings.autoStart.onClick = function(){
		if( script.appName == 'Illustrator' ){
			alert( 'For auto startup of the application, place script file in directory:\r'+script.getStartupFolder().fsName );
			this.value = false;
			return;
			}
		var alias = script.getFileAlias(script.getStartupFolder(), script.file, this.value);
		if(!alias)
			this.value = false;
		else if(!this.value)
			alias.remove();
		}
	winSettings.autoSave.onClick = function(){
		OPTIONS.autoSave = this.value;
		}
	if( File.fs == 'Windows' && !isAI ){
		winSettings.debugFocus.onClick = function(){
			OPTIONS.debugFocus = this.value;
			}
		}
	winSettings.buts.info.onClick = function(){
		script.getWinInfo( '', help );
		}
	winSettings.buts.Close.onClick = function(){
		this.window.close();
		}
	winSettings.center();
	winSettings.show();
	}catch(err){script.alertError(err)};
	}

//================ SELECT GROUP ===============================
function selectGroup(groupIndex){
	try{
	for(var i = 0; i < win.Tabs.children.length; i++){
		if(i==groupIndex){
			win.Tabs.children[i].enabled = false;
			win.Frame.Grps.children[i].visible = true;
			continue;
			}
		win.Tabs.children[i].enabled = true;
		win.Frame.Grps.children[i].visible = false;
		}
	}catch(err){script.alertError(err)};
	}
//================ ADD GROUP ===============================
function addGroup(New){
	try{
	var item = win.Tabs.add( 'iconbutton' );
	item.isTab = true;
	item.preferredSize = [20,20];
	item.titleLayout.margins = [6,3,0,0];
	item.titleLayout.spacing = 0;
	item.title = "W"; // назначаем длинный символ для создания поля title, достаточного для любого одиночного символа
	item.titleLayout.characters = 1;
	item.title = ""; // сбрасываем значение
	item.onClick = function(){
		selectGroup(script.getUiObjectIndex(this));
		}
	item = win.Frame.Grps.add('group');
	// UI-объект Group не имеет properties, поэтому для идентифицируем групп используем заказные свойства самого объекта
	item.isItemsGroup = true;
	item.orientation = win.orientation;
	item.spacing = 5;
	item.alignment = ['fill', 'fill'];
	item.alignChildren = ['fill', 'top'];
	if(New){
		win.layout.layout(true);
		selectGroup(win.Tabs.children.length-1);
		CHANGES.setStatus();
		}
	return item;
	}catch(err){script.alertError(err)};
	}
//================ GROUP ITEMS ===================================
function getGroupItemData( groupItem ){
	if( groupItem.type == 'iconbutton' && (groupItem.parent.isIconsField || groupItem.parent.isIconsGroup) )
		return getIconButtonData( groupItem );
	// button
	if( groupItem._current.isButton ){
		var button = groupItem._button;
		var font = script.addFont( button );
	//	var color = script.getRGB( groupItem, 'foregroundColor' );
	//	if( color && color[0] == 255 && color[1] == 255 && color[2] == 255 )
	//		color = false;
		return {
			type: 'button',
			name: button.text,
			adaptFsNames: button.helpTip ? [button.helpTip] : [],
			fontStyle: font && font.style != 'REGULAR' ? font.style : '',
	//		color: color
			};
		}
	else if( groupItem._current.isList ){
		/*
		var list = groupItem._list;
		
		// вызываем событие focus для инициации списка
		var event = ScriptUI.events.createEvent( 'MouseEvent' );
		event.initMouseEvent( 'focus' );
		list.dispatchEvent( event );
					
		var adaptFsNames = [];
		if( !list.autoFillFromFolderPath )
			for( var i = 2; i < list.items.length; i++ )
				adaptFsNames.push( list.items[i].adaptFsName );
		else
			adaptFsNames.push( list.helpTip );
		*/
		return {
			type: 'dropdownlist',
			name: groupItem._list.items[0].text,
			autoFillFromFolder: groupItem._list.autoFillFromFolder,
			adaptFsNames: groupItem._list.adaptFsNames,
			};
		}
	else if( groupItem._current.isIconsGroup ){
		var iconsGroup = groupItem._iconsGroup;
		var iconButtonDatas = [];
		for( var i = 0; i < iconsGroup.children.length; i++ )
			iconButtonDatas.push( getIconButtonData(iconsGroup.children[i]) );
		return {
			type: 'iconsgroup',
			name: "",
			iconButtonDatas: iconButtonDatas,
			};
		}
	
	}
//================ ADD ITEM ===============================
function addGroupItem( group, itemData, refreshLayout ){ // return groupItem
	try{
	if( !itemData )
		return; // alert( 'Error addGroupItem(): itemData is undefined' );
	
	if( group.isIconsField || group.isIconsGroup )
		return addIconButton( group, itemData, refreshLayout );
	
	var groupItem = group.add('group', undefined, undefined);
	groupItem.orientation = 'stack';
	groupItem.alignChildren = ['fill', 'top'];
	
	if( OPTIONS.buttonsWidth )
//		groupItem.preferredSize.width = OPTIONS.buttonsWidth;
		groupItem.minimumSize.width = groupItem.maximumSize.width = OPTIONS.buttonsWidth;
	
	if( !addItem(groupItem, itemData, refreshLayout) ){
		groupItem.parent.remove( groupItem );
		return;
		}
	return groupItem;
	}catch(err){script.alertError(err)};
	}
function addItem( groupItem, itemData, refreshLayout ){ // return item or undefined
	if( !itemData )
		return; // alert( 'Error addGroupItem(): itemData is undefined' );
	if( itemData.type == 'dropdownlist' )
		return addList( groupItem, itemData, refreshLayout );
	else if( itemData.type == 'iconsgroup' )
		return addIconsGroup( groupItem, itemData, refreshLayout );
	else // button/iconbutton
		return addButton( groupItem, itemData, refreshLayout );
	}
//================ ADD LIST ===============================
function addList( groupItem, itemData, refreshLayout ){
	try{
	
	if( !groupItem._list ){
		groupItem._list = groupItem.add('dropdownlist', undefined, undefined, {items:['','-','','-']});
		groupItem._list.isItem = true;
		groupItem._list.isList = true;
		
	//	groupItem._list.items[0].enabled = false;
		groupItem._list.onChange = function(){
			this.active = false;
			if( !this.selection.index )
				return;
			if( this.selection.adaptFsName ){
				this.items[2].text = this.selection.text;
				this.items[2].adaptFsName = this.selection.adaptFsName;
				launchFsObject( this.selection.adaptFsName, this );
				}
			this.selection = 0;
			this.active = false;
			}
		// Инициация списка - при первом выборе
		// Illustrator Windows - 'focus' не работает
		// MacOS - не работает ни focus, ни onActivate
		if( File.fs == 'Windows' )
			groupItem._list.onActivate = init_list_funct;
		/*
		groupItem._list.addEventListener(
			'focus', 
			init_list_funct, 
			false
			);
			*/
		}
	
	groupItem._list.autoFillFromFolder = itemData.autoFillFromFolder;
	groupItem._list.helpTip = itemData.autoFillFromFolder ? itemData.adaptFsNames[0] : '';
	groupItem._list.items[0].text = itemData.name;
	groupItem._list.selection = 0;
	groupItem._list.adaptFsNames = itemData.adaptFsNames;
	
	groupItem._list._refresh = true;
	if( File.fs == 'Macintosh' )
		init_list_funct( {target: groupItem._list} );
	
	if( groupItem._current != groupItem._list ){
		if( groupItem._current )
			groupItem._current.visible = false;
		groupItem._current = groupItem._list;
		groupItem._list.visible = true;
		}
	
	if( refreshLayout )
		win.layout.layout( true );
	groupItem._list.active = false;
	return groupItem._list;
	}catch(err){script.alertError(err)};
	}
// единая ф-ция для метода onActivate и события 'focus'
function init_list_funct( e ){
	var list = e ? e.target : this;
	
	if( !list._refresh )
		return;
	list._refresh = false;
	
//	$.writeln( 'focus' );
	for( var i = list.items.length-1; i > 3; i-- )
		list.remove( list.items[i] );
	list.items[2].text = '';
	list.items[2].adaptFsName = '';
	
	var adaptFsNames = [];
	if( list.autoFillFromFolder ){
		var folder = getFsObject( list.adaptFsNames[0] );
		if( folder.exists ){
			var files = folder.getFiles( function(f){ return f instanceof File && regExpFileFilterForAutoList.test(f.fsName) ? true : false } );
			for( var i = 0; i < files.length; i++ )
				adaptFsNames.push( files[i].fsName );
			}
		}
	else
		adaptFsNames =  list.adaptFsNames;
	
	for( var i = 0; i < adaptFsNames.length; i++ )
		list.add( 'item', adaptFsNames[i].split(/[\\\/]/).reverse()[0] ).adaptFsName = adaptFsNames[i];
	
	return true;
	}
//================ ADD BUTTON ===============================
function addButton( groupItem, itemData, refreshLayout ){
	try{
	if( !groupItem._button ){
		groupItem._button = groupItem.add('button', undefined, undefined);
		groupItem._button.isItem = true;
		groupItem._button.isButton = true;
		
		groupItem._button.preferredSize.height = 22;
		groupItem._button.onClick = function(){
			this.active = false;
			launchFsObject(this.helpTip, this);
			this.active = false;
			}
		}
	
	groupItem._button.text = itemData.name;
	groupItem._button.helpTip = itemData.adaptFsNames.length ? itemData.adaptFsNames[0] : '';
	if( itemData.fontStyle )
		script.addFont( groupItem._button, {style: itemData.fontStyle} );
	else if( script.addFont(groupItem._button) )
		script.addFont( groupItem._button, {style: 'REGULAR'} );
//	if( itemData.color )
//		script.addColor( button, 'foregroundColor', itemData.color );
//	else if( script.addColor(button) )
//		script.addColor( button, 'foregroundColor', [255,255,255] );
	
	if( groupItem._current != groupItem._button ){
		if( groupItem._current )
			groupItem._current.visible = false;
		groupItem._current = groupItem._button;
		groupItem._button.visible = true;
		}
	
	if( refreshLayout )
		win.layout.layout( true );
	
	return groupItem._button;
	}catch(err){script.alertError(err)};
	}
//================ ICONS GROUP ===============================
function addIconsGroup( groupItem, itemData, refreshLayout ){
	try{
	// Проблемы в MacOS: объект Panel  в группах иконок не ловил события нажатия мыши --> не вызывается контекстное меню.
	var iconsGroup_type = File.fs == 'Windows' ? 'panel' : 'group';
	if( !groupItem._iconsGroup ){
		groupItem._iconsGroup = groupItem.add(iconsGroup_type, undefined, undefined);
		groupItem._iconsGroup.isItem = true;
		groupItem._iconsGroup.isIconsGroup = true;
		
		groupItem._iconsGroup.orientation = 'row';
		groupItem._iconsGroup.alignment = 'fill';
		groupItem._iconsGroup.margins = [2,0,2,0];
		groupItem._iconsGroup.spacing = 5;
		groupItem._iconsGroup.preferredSize.height = 24;
//		groupItem._iconsGroup.minimumSize.height = groupItem._iconsGroup.maximumSize.height = 30;
		if( iconsGroup_type == 'group' )
			script.addColor( groupItem._iconsGroup, 0, iconsFieldColor );
		}
	else{
		for( var i = groupItem._iconsGroup.children.length-1; i > -1; i-- )
			groupItem._iconsGroup.remove( i );
		}
	
	if( itemData.iconButtonDatas )
		for( var i = 0; i < itemData.iconButtonDatas.length; i++ )
			addIconButton( groupItem._iconsGroup, itemData.iconButtonDatas[i], refreshLayout );
	
	if( groupItem._current != groupItem._iconsGroup ){
		if( groupItem._current )
			groupItem._current.visible = false;
		groupItem._current = groupItem._iconsGroup;
		groupItem._iconsGroup.visible = true;
		}
	
	if( refreshLayout )
		win.layout.layout( true );
	
	return groupItem._iconsGroup;
	}catch(err){script.alertError(err)};
	}
//================ ICON BUTTON ===============================
function visibleIconsField( opts ){ // value = true|false|undefined. Return Bool
// opts = {iconsField: iconsField, value: true|false|undefined, layout: bool}
	if( opts.value === true || opts.value === false ){
		opts.iconsField.maximumSize.width = opts.value ? 3000 : 0;
		if( opts.iconsField.isIconsField_Top || opts.iconsField.isIconsField_Bottom )
			opts.iconsField.maximumSize.height = opts.value ? 3000 : 0;
		if( opts.layout ){
			win.layout.layout( true );
			CHANGES.setStatus();
			}
		}
	return opts.iconsField.maximumSize.width != 0;
	}
function alignmentIconsField( opts ){ // Return string
	// opts = {iconsField: iconsField, value: left|right|top|bottom|center|undefined, layout: bool}
	var resultValue;
	if( opts.value ){
		if( opts.iconsField.isIconsField_Top || opts.iconsField.isIconsField_Bottom ){
			resultValue = /left|right|center/.test( opts.value ) ? opts.value : 'left';
			opts.iconsField.alignChildren = [resultValue, 'top'];
			}
		else{
			resultValue = /top|bottom|center/.test( opts.value ) ? opts.value : 'top';
			opts.iconsField.alignChildren = ['left', resultValue];
			}
		if( opts.layout ){
			win.layout.layout( true );
			CHANGES.setStatus();
			}
		}
	return opts.iconsField.isIconsField_Top || opts.iconsField.isIconsField_Bottom ? opts.iconsField.alignChildren[0] : opts.iconsField.alignChildren[1];
	}
function getIconButtonData( iconButton ){
	return {
		type: 'iconbutton',
		name: "",
		adaptFsNames: iconButton.helpTip ? [iconButton.helpTip] : [],
		iconPath: (iconButton.image ? iconButton.image.pathname : ''),
		};
	}
function addIconButton( iconsContainer, itemData, refreshLayout ){
	try{
	if( itemData.type == 'dropdownlist' )
		return;
	var iconButton = iconsContainer.add('iconbutton', undefined, undefined, {style: 'toolbutton'});
	iconButton.isItem = true;
	iconButton.isIconButton = true;
	
	iconButton.preferredSize = iconButton.minimumSize = iconButton.maximumSize = [22,22];
	var iconPath = itemData.iconPath ? itemData.iconPath : script.images.default_icon.pathname; // "/Graphics/(Color Picker Panel Resources)/idrc_PNGR/2510.idrc";
//	$.writeln( iconPath );
	addIcon( { iconButton: iconButton, iconPath: iconPath, text: 'Q', helpTip: (itemData.adaptFsNames.length ? itemData.adaptFsNames[0] : '') } );
	iconButton.onClick = function(){
		this.active = false;
		launchFsObject(this.helpTip, this);
		this.active = false;
		}
	if( refreshLayout )
		win.layout.layout( true );
	CHANGES.setStatus();
	return iconButton;
	}catch(err){script.alertError(err)};
	}

function setIcon( EVENT ){ // opts = { iconButton, iconPath, text, helpTip }
	try{
	var icon_path = '';
	
	var icon_win = new Window("dialog", undefined, undefined, );
	icon_win.preferredSize.width = 500;
	icon_win.margins = 5;
	icon_win.spacing = 5;
	with(icon_win){
		icon_win.group = add( "group", undefined, undefined );
		icon_win.group.alignChildren = ['center', 'center'];
		with(icon_win.group){
			icon_win.group.select_image = add( "button", undefined, 'Select Image' );
			icon_win.group.select_image.preferredSize.width = 130;
			if( script.getAppName('indesign') ){
				icon_win.group.select_id_icon = add( "button", undefined, 'Select InDesign Icon' );
				icon_win.group.select_id_icon.preferredSize.width = 130;
				}
			}
		icon_win.icon_path = add( "edittext", undefined, undefined, {readonly: 'true', } );
		icon_win.icon_path.alignment = ['fill', 'top'];
		icon_win.the_image = add( "image", undefined, undefined );
		icon_win.the_image.preferredSize = [20,20];
		icon_win.cancel_ok = add( "group", undefined, undefined );
		icon_win.cancel_ok.alignment = ['right', 'top'];
		with(icon_win.cancel_ok){
			icon_win.cancel_ok.cancel = add( "button", undefined, 'Cancel' );
			icon_win.cancel_ok.ok = add( "button", undefined, 'Ok' );
			}
		}
	icon_win.group.select_image.onClick = function(){
		var file = File.openDialog( "Select icon file", "Files: *.png; *.jpg" );
		if( file ){
			var res = addIcon( { iconButton: icon_win.the_image, iconPath: file.fsName } );
			icon_path = res == true ? file.fsName : '';
			icon_win.icon_path.text = res.constructor == Error ? res + ', line ' + res.line : icon_path;
			}
		}
	if( script.getAppName('indesign') ){
		icon_win.group.select_id_icon.onClick = function(){
			var path = prompt( 'Input Indesign Icon short path', '/Graphics/(Color Picker Panel Resources)/idrc_PNGR/2510.idrc' );
			if( !path )
				return;
			if( path.split('.').reverse()[0].toLowerCase() != 'idrc' )
				return alert( 'Incorrect value: ' + res );
			var res = addIcon( { iconButton: icon_win.the_image, iconPath: path } );
			icon_path = res == true ? path : '';
			icon_win.icon_path.text = res.constructor == Error ? res + ', line ' + res.line : icon_path;
			}
		}
	icon_win.cancel_ok.cancel.onClick = function(){
		icon_path = '';
		icon_win.close();
		}
	icon_win.cancel_ok.ok.onClick = function(){
		icon_win.close();
		}
	icon_win.center();
	icon_win.show();
	
	if( icon_path )
		addIcon( { iconButton: EVENT.target, iconPath: icon_path } );
	}catch(err){script.alertError(err)};
	}
function addIcon( opts ){ // opts = { iconButton, iconPath, text, helpTip }
	try{
	var icon;
	if( opts.iconPath ){
		if( opts.iconPath.split('.').reverse()[0].toLowerCase() == 'idrc' ){
			icon = script.getInDesignIcon( opts.iconPath ); // example: script.getInDesignIcon( '/Text/(Find and Change Panel Resources)/idrc_PNGA/113.idrc' );
			if( !icon )
				script.alertError( 'Incorrect path: ' + opts.iconPath );
			}
		else{
			var file = getFsObject(opts.iconPath);
			if( !file.exists )
				script.alertError( 'File not found: ' + file.fsName );
			else
				icon = ScriptUI.newImage( file.fsName );
			}
		}
	if( icon ){
//		var uiObject_size = opts.iconButton.size ? opts.iconButton.size : opts.iconButton.preferredSize;
//		if( icon.size[0] <= uiObject_size[0] && icon.size[1] <= uiObject_size[1] )
			opts.iconButton.image = icon;
//		else{  // если иконка  не вписывается в габариты
//			script.getCustomDraw(opts.iconButton, {uiImage: icon});
//			}
		opts.iconButton.active = false;
		}
	/*
	else if( opts.text ){
		script.getCustomDraw(opts.iconButton, {text:opts.text});
		}
	*/
	if( opts.helpTip )
		opts.iconButton.helpTip = opts.helpTip;
	
	CHANGES.setStatus();
	return true;
	}catch( err ){
		script.alertError( err );
		return err;
		}
	}
//================ ORIENTATION ===============================
function paletteOrientation(orientation){
	win.orientation = orientation;
//	win.Settings.preferredSize = orientation == 'column' ? [100,22] : [22,22];
	
	win.Frame.IconsField_Left.orientation = orientation;
	win.Frame.IconsField_Right.orientation = orientation;
	
	for(var i = 0; i<win.Frame.Grps.children.length; i++)
		win.Frame.Grps.children[i].orientation = orientation;
	
	win.layout.layout(true);
	}

//================ SETS ===============================
function getFolderSetsPath(){
	if( USER_FOLDER ){
		if( Folder(USER_FOLDER).exists )
			return USER_FOLDER;
		else{
			if( !this.Flag )
				alert( script.localize("Folder not found")+': ' + USER_FOLDER);
			this.Flag = true;
			}
		}
	return script.file.parent.fsName;
	}
function getFileSets(){
	var fileSets = new File( getFolderSetsPath() + '/' + script.name + '_sets.xml');
	
	if( !fileSets.exists ){
		// Конвертация старой версии файла наборов в xml-формат
		var old_file = new File( getFolderSetsPath() + '/' + script.name + '_sets.txt');
		if( !old_file.exists )
			return fileSets;
		
		old_file.open( 'r' );
		var res = old_file.read();
		old_file.close();
		
		if( !res )
			return fileSets;
		//	return alert( 'File is empty: ' + old_file.fsName );
		
		var obj;
		try{ eval( 'obj = ' + res + ';' ); }catch(err){}
		if( !obj )
			return fileSets;
		//	return alert( 'File not contains data: ' + old_file.fsName );
		
		var XML = <sets/>;
		var set;
		for( var z in obj ){
			set = <set title={obj[z].title}/>
			for( var i = 0; i < obj[z].buttons.length; i++ )
				set.appendChild( convertItemDataToXml( obj[z].buttons[i] ) );
			XML.appendChild( set );
			}
		script.write_xml_file( fileSets , XML );
		}
	
	return fileSets;
	}
function loadSets(){
	var file = getFileSets();
	if(!file.exists){
		add_default_group_and_buttons();
		return;
		}
//	var SET = script.sourceToObject( script.fileRead(file) );
	var XML_SETS = script.read_xml_file( file ); // return XML or false or Error (if returnError = true)
	if( !XML_SETS ){
		add_default_group_and_buttons();
		return;
		}
	activateSets( XML_SETS );
	}
function add_default_group_and_buttons(){
	var group = addGroup();
	addGroupItem( group, {type: 'button', name: "Desktop", adaptFsNames: [getAdaptFsName(Folder.desktop)]}, true );
	var scripts = new Folder( app.filePath.fsName + '/Scripts/Scripts Panel/Samples/JavaScript').getFiles( '*jsx' );
	if( scripts.length ){
		addGroupItem( group, {type: 'button', name: script.getFileName(scripts[0]), adaptFsNames: [getAdaptFsName(scripts[0])]}, true );
		if( scripts[1] )
			addGroupItem( group, {type: 'button', name: script.getFileName(scripts[1]), adaptFsNames: [getAdaptFsName(scripts[1])]}, true );
		}
	}
function saveSets( autoSave ){
	if(!CHANGES.status)
		return;
	if( autoSave ){
		}
	else if( !OPTIONS.autoSave && !confirm('Save changes?') )
		return;
	
	var xml = getXMLSets();
	if( xml ){
		script.write_xml_file( getFileSets(), xml );
		CHANGES.status = false;
		}
	}
function getDefaultXMLSets(){
	return <sets>
		<iconsSet location="left" alignment="top" visible="true"/>
		<iconsSet location="right" alignment="top" visible="true"/>
		<iconsSet location="top" alignment="left" visible="true"/>
		<iconsSet location="bottom" alignment="left" visible="true"/>
		<set/>
	</sets>;
	}

function convertItemDataToXml( itemData ){ // return xml <item/>
	try{
	var xml_item = <item type={itemData.type} name={itemData.name}/>;
	switch( itemData.type ){
		case 'button':
			xml_item.@fontStyle = itemData.fontStyle;
		break;
		case 'iconbutton':
			var icon_file = new File( itemData.iconPath );
			var iconPath = getAdaptFsName( icon_file );
			if( iconPath.charAt(0) != '.' )
				iconPath = script.getInDesignIconShortPath( icon_file );
			xml_item.@iconPath = getAdaptFsName( iconPath );
		break;
		case 'dropdownlist':
			xml_item.@autoFillFromFolder = itemData.autoFillFromFolder ? true : false;
		break;
		case 'iconsgroup':
			for( var i = 0; i < itemData.iconButtonDatas.length; i++ )
				xml_item.appendChild( convertItemDataToXml(itemData.iconButtonDatas[i]) );
		break;
		}
	
	if( itemData.adaptFsNames )
		xml_item.appendChild( itemData.adaptFsNames.join('|') );
	else if( itemData.adaptFsName ) // old format
		xml_item.appendChild( itemData.adaptFsName );
	
	return xml_item;
	}catch(err){ alert( itemData ); script.alertError(err); throw err; }
	}

function getXMLSets(){
	try{
	var XML_SET = <sets/>;
	var group, set;
	
	// IconsField
	XML_SET.appendChild( getXMLIconsSet( win.Frame.IconsField_Left, 'left' ) );
	XML_SET.appendChild( getXMLIconsSet( win.Frame.IconsField_Right, 'right' ) );
	XML_SET.appendChild( getXMLIconsSet( win.IconsField_Top, 'top' ) );
	XML_SET.appendChild( getXMLIconsSet( win.IconsField_Bottom, 'bottom' ) );
	// Sets
	for(var i = 0; i < win.Frame.Grps.children.length; i++ ){
		set = <set title={win.Tabs.children[i].title}/>
		group = win.Frame.Grps.children[i];
		for( var z = 0; z < group.children.length; z++ )
			set.appendChild( convertItemDataToXml( getGroupItemData(group.children[z]) ) );
		XML_SET.appendChild( set );
		}
//	alert( XML_SET.toXMLString() );
	return XML_SET;
	}catch(err){ script.alertError(err); }
	}
function getXMLIconsSet( iconsField, location ){
	var set = <iconsSet location={location} alignment={alignmentIconsField( {iconsField: iconsField, value: undefined, layout: false} )} visible={visibleIconsField({iconsField: iconsField, value: undefined, layout: false})}/>
	for( var z = 0; z < iconsField.children.length; z++ )
		set.appendChild( convertItemDataToXml( getIconButtonData(iconsField.children[z]) ) );
	return set;
	}
function activateSets( XML_SETS ){
//	alert( SET.toSource() );
	try{
	var xml_set, xml_item, itemData;
	
	CHANGES.access = false; // отключаем прослушивание изменений
	
	// IconsField
	var iconsField, default_alignment;
	for(var i = 0; i < XML_SETS.iconsSet.length(); i++){
		xml_set = XML_SETS.iconsSet[i];
		switch( xml_set.@location.toString() ){
			case 'left': iconsField = win.Frame.IconsField_Left; default_alignment = 'top'; break;
			case 'right': iconsField = win.Frame.IconsField_Right; default_alignment = 'top'; break;
			case 'top': iconsField = win.IconsField_Top; default_alignment = 'left'; break;
			case 'bottom': iconsField = win.IconsField_Bottom; default_alignment = 'left'; break;
			default: iconsField = undefined;
			}
		if( !iconsField )
			continue;
		for(var z = 0; z < xml_set.item.length(); z++)
			addIconButton( iconsField, convertXMLToItemData(xml_set.item[z]) );
		visibleIconsField( {iconsField: iconsField, value: xml_set.@visible.toString() == 'true', layout: false} ); // value: true|false|undefined. Return Bool
		alignmentIconsField( {iconsField: iconsField, value: (xml_set.@alignment.toString()||default_alignment), layout: false} );
		}
	
	// Sets
	for( var i = 0; i < XML_SETS.set.length(); i++ ){
		xml_set = XML_SETS.set[i];
		var group = addGroup();
		win.Tabs.children[i].title = xml_set.@title.toString();
		for(var z = 0; z < xml_set.item.length(); z++)
			addGroupItem( group, convertXMLToItemData(xml_set.item[z]) );
		}
	
	CHANGES.access = true; // включаем прослушивание изменений
	
	win.layout.layout( true );
	return true;
	}catch(err){
		script.alertError(err);
		CHANGES.access = true; // включаем прослушивание изменений
		return false;
		}
	}
function convertXMLToItemData( xml_item ){
	var itemData = {
		type: xml_item.@type.toString(),
		name: xml_item.@name.toString(),
		adaptFsNames: xml_item.text().toString().split( '|' ),
		}
	switch( xml_item.@type.toString() ){
		case 'button':
			itemData.fontStyle = xml_item.@fontStyle.toString();
		break;
		case 'dropdownlist':
			itemData.autoFillFromFolder = xml_item.@autoFillFromFolder.toString() == 'true';
		break;
		case 'iconbutton':
			itemData.iconPath = xml_item.@iconPath.toString();
		break;
		case 'iconsgroup':
			itemData.iconButtonDatas = [];
			for( var i = 0; i < xml_item.item.length(); i++ )
				itemData.iconButtonDatas.push( convertXMLToItemData(xml_item.item[i]) );
		break;
		}
	return itemData;
	}
// ======================================================================
// ======================================================================
function getUINumberField( properties ){
	// v.3.2
	/*
	properties = {
		currentValue: 0, // Number. Default: 0
		maxValue: 100, // Number. Default: Number.POSITIVE_INFINITY
		minValue: 1, // Number. Default: Number.NEGATIVE_INFINITY
		emptyValue: false, // Bool. Default: false. Может ли поле принимать пустое значение
		callback: function( oldNum, newNum ){ return newNum }, // Function. Default: function( oldNum, newNum ){ return newNum }
		
		uiField: undefined, // EditText object. Если указан этот параметр - нижеследующие параметры не учитываются
		
		uiContainer: undefined, // UI-object: Window, Panel, Group or Tab
		buttons: false, // Bool. Default: false
		step: 1, // Number. Default: 1
		secondButtons: false, // Bool. Default: false
		secondStep: 0.1, // Number. Default: 0.1
		prefix: '', // String
		postfix: '', // String
		readOnly: false, // Bool. Default: false
		}
	return object {
		currentValue: num или '' (пустая строка при пустом значении поля),
		minValue: num,
		maxValue: num,
		step: num,
		secondStep: num,
		enabled: bool,
		readOnly: bool,
		}
	При изменении значений minValue и maxValue после создания объекта следует обновлять значение currentValue: numberField.currentValue = numberField.currentValue
	*/
	properties = properties ? properties : {};
	// вычисляем начальное значение
	var numberField = {
		// edited values
		currentValue: properties.emptyValue ? getNumber( properties.currentValue, '' ) : getNumber( properties.currentValue, 0 ), // default: '' или 0
		minValue: getNumber( properties.minValue, Number.NEGATIVE_INFINITY ), // default: Number.NEGATIVE_INFINITY
		maxValue: getNumber( properties.maxValue, Number.POSITIVE_INFINITY ), // default: Number.POSITIVE_INFINITY
		step: getNumber( properties.step, 1 ), // default: 1
		secondStep: getNumber( properties.secondStep, 0.1 ), // default: 0.1
		enabled: true,
		readOnly: ( properties.readOnly ? true : false ),
		}
	// static values
	var callback = ( properties.callback && properties.callback.constructor == Function ? properties.callback : function( oldNum, newNum ){ return newNum } );
	var buttons = properties.buttons || false; // default: false
	var secondButtons = properties.secondButtons || false; // default: false
	var prefix = properties.prefix || '';
	var postfix = properties.postfix || '';
//			var readOnly = ( properties.readOnly ? true : false ); // default: false
	
	var textField;
	var parentGroup;
	if( properties.uiField && properties.uiField.constructor == EditText ){ // используем переданный 
		textField = properties.uiField;
		textField.text = numberField.currentValue;
		}
	else{
		var buttons, secondButtons;
		parentGroup = properties.uiContainer.add( 'group' );
		parentGroup.orientation = 'row';
		parentGroup.spacing = 0;
		with( parentGroup ){
			if( prefix )
				parentGroup.add( 'statictext', undefined, prefix.toString() );
			parentGroup.box = add( 'group' );
			parentGroup.box.orientation = 'row';
			parentGroup.box.margins = [5,0,5,0];
			parentGroup.box.spacing = 0;
			with( parentGroup.box ){
				textField = add( 'edittext', undefined, numberField.currentValue ); //, {readonly: readOnly} );
				textField.preferredSize = [70,22];
				}
			if( buttons ){
				buttons = getButtons( parentGroup.box, 'step' );
				if( secondButtons )
					secondButtons = getButtons( parentGroup.box, 'secondStep' );
				}
			if( postfix )
				parentGroup.add( 'statictext', undefined, postfix.toString() );
			}
		}
	textField.enabled = numberField.readOnly ? false : true;
	textField.onChange = function(){
		numberField.currentValue = this.text;
		}
	numberField.watch( 'currentValue', numWatcher );
	numberField.watch( 'minValue', numWatcher );
	numberField.watch( 'maxValue', numWatcher );
	numberField.watch( 'readOnly', enabled_readOnly_watcher );
	numberField.watch( 'enabled', enabled_readOnly_watcher );
	// return
	return numberField;
	// =========================================
	// functs
	function getButtons( container , stepKey ){
		var buttons;
		if( File.fs == 'Macintosh' || /photoshop/i.test(app.name) ){
			buttons = container.add( "group", undefined, undefined );
			buttons.orientation = 'column';
			buttons.margins = [0,0,3,0];
			buttons.spacing = 0;
			buttons.preferredSize = [15,22];
			buttons.plus = buttons.add( 'iconbutton' );
			buttons.minus = buttons.add( 'iconbutton' );
			buttons.plus.preferredSize = buttons.minus.preferredSize = [15,11];
			buttons.plus.onClick = function(){
				numberField.currentValue = Number( numberField.currentValue.toString() ) + numberField[stepKey];
				}
			buttons.minus.onClick = function(){
				numberField.currentValue = Number( numberField.currentValue.toString() ) - numberField[stepKey];
				}
			}
		else{
			buttons = container.add( "scrollbar", undefined, undefined );
			buttons.preferredSize = [20,22];
			buttons.onChanging = function(){
				if( this.value )
					numberField.currentValue = Number( numberField.currentValue.toString() ) - numberField[stepKey];
				else
					numberField.currentValue = Number( numberField.currentValue.toString() ) + numberField[stepKey];
				this.value = 0;
				}
			}
		numberField.watch( stepKey, numWatcher );
		return buttons;
		}
	function enabled_readOnly_watcher(){ // arguments = [имя свойства, старое значение, новое значение]
		// INI
		if(arguments[1] === arguments[2])
			return arguments[1];
		var newValue;
		if(arguments[2] === true)
			newValue = true;
		else if(arguments[2] === false)
			newValue = false;
		else // incorrect type
			return arguments[1];
		// EXE
		if( arguments[0] == 'enabled' ){
			if( parentGroup )
				parentGroup.enabled = newValue;
			else if( numberField.readOnly != !newValue )
				numberField.readOnly = !newValue;
			return newValue;
			}
		else if( arguments[0] == 'readOnly' ){
			textField.enabled = !newValue;
			if( !parentGroup && numberField.enabled != !newValue )
				numberField.enabled = !newValue;
			return newValue;
			}
		else return arguments[1];
		};
	function numWatcher(){ // arguments = [имя свойства, старое значение, новое значение]
		if( properties.emptyValue && arguments[2] === '' && arguments[0] == 'currentValue' ){
			var num = '';
			if( num !== arguments[1] ){
				var callback_num = callback( arguments[1], num );
				if( num !== callback_num && !isNaN(getNumber(callback_num, NaN)) )
					num = callback_num;
				}
			textField.text = num;
			return num;
			}
		//
		var num = getNumber( arguments[2], NaN );
		if( isNaN(num) )
			num = arguments[1];
		if( arguments[0] == 'currentValue' ){
			if( num > numberField.maxValue )
				num = numberField.maxValue;
			else if( num < numberField.minValue )
				num = numberField.minValue;
			if( num != arguments[1] ){
				var callback_num = callback( arguments[1], num );
				if( num !== callback_num && !isNaN(getNumber(callback_num, NaN)) ){
					if( numberField.minValue > callback_num )
						num = numberField.minValue;
					else if( numberField.maxValue < callback_num )
						num = numberField.maxValue;
					else
						num = callback_num;
					}
				}
			textField.text = num;
			}
		return num;
		}
	function getNumber( value, defaultValue ){
		return value === 0 || ( value && isFinite(value) ) ? +value : defaultValue;
		}
	}


evalScript_function = function( file ){
	$.evalFile( file );
	}

// =========================================================================
// LIB
// =========================================================================
function getScriptLibrary( scriptArgs ){
//	scriptArgs = {
//		scriptFile: File
//		name: '', 
//		version: Number, 
//		autor: '', 
//		mail: '', 
//		sites: [ '','' ](URLs), 
//		release: Number (year), 
//		supportApp: [ 'InDesign5', 'Photoshop10', 'Illustrator13', 'InDesign6', 'Photoshop11', 'Illustrator14' ], 
//		supportFS: [ 'Windows', 'Macintosh' ] ,
//		prefsInit: Boolean,
//		log: Boolean, init output messages to log-file
//		logWithoutStart: Boolean\
//		workingDirectory: Folder (Optional)
//		targetengine: Bool (Default - false)
//		notShowAlert: Bool
//		}
	if( !scriptArgs ) scriptArgs = {};
	var lib = getLib();
	lib.file = scriptArgs.scriptFile || lib.getThisFile();
	if( !lib.file )
		throw new Error( 'Error: current script file not defined' );
	lib.name = scriptArgs.name || lib.getFileNameOnly( lib.file );
	lib.setTargetengine( scriptArgs.targetengine );
	// log
	lib.logInit = scriptArgs.log;
	lib.logWithoutStart = scriptArgs.logWithoutStart;
	lib.logFILE = new File( lib.file.parent.absoluteURI + '/log.txt' );
	lib.LOG();
	// переводим supportApp в объект
	var _supportApp_ = lib.supportApp;
	lib.supportApp = {};
	for( var i =0; i < _supportApp_.length; i++ ){
		try{
		var parse = /^(.*?)([\d\.]+)?$/.exec(_supportApp_[i]);
		if( parse && parse[1] ){
			var version = parse[2] ? parseFloat(parse[2]) : 0;
			if( lib.supportApp[parse[1]] )
				lib.supportApp[parse[1]] = Math.min( lib.supportApp[parse[1]], version );
			else lib.supportApp[parse[1]] = version;
			}
		}catch(err){}
		}
	// prefs init
	lib.workingDirectory = scriptArgs.workingDirectory;
	if( scriptArgs.prefsInit )
		lib.initXMLOptions();
	return lib;
	function getLib(){
		var scriptLIB;
		scriptLIB = {
		libraryVersion: 2.03, // версия библиотеки script
		extensions: {},//объект для регистрации подгруженных расширений
		version: scriptArgs.version || 1,
		autor: scriptArgs.autor || 'Alexey Dmitrienko',
		mail: scriptArgs.mail || 'alexey-dmitrienko@ya.ru',
		sites: scriptArgs.sites || [
	//		'www.sites.google.com/site/scriptuibuilder/'
			],
		release: scriptArgs.release || new Date().getFullYear(),
		supportApp: scriptArgs.supportApp || [ // пустой массив - поддержка без ограничений, затем он будет переведен в объект {<appName>: <minVersion>}
			// 'InDesign5', 'Photoshop10', 'Illustrator13', 
			],
		supportFS: scriptArgs.supportFS || [ // пустой массив - поддержка без ограничений
			// 'Windows', 'Macintosh' 
			],
		targetengine: false,
		setTargetengine: function( bool ){
			if( !arguments.length ) return;
			if( bool && lib.getAppName('photoshop') )
				return;
			this.targetengine = bool ? true : false;
			},
		notShowAlert: scriptArgs.notShowAlert,
		//============= Log ==============================
		logInit: false, // вывод в log-файл отключен
		logFILE: false, // основной файл для вывода лога, переменная заполнится при инициализации библиотеки
		logFiles: [],
		addLogFile: function( file ){
			if( file && file instanceof File )
				this.logFiles.push( file );
			},
		logSTRING: '',
		LOG: function( str, write ){ // write = true
			try{
			if( !this.logInit )
				return;
			if( !this.logStarted ){
				this.logStarted = new Date();
				if( !this.logWithoutStart ){
					this.logSTRING = '===============================================\n';
					this.logSTRING += '[' + this.getFormattedDateTime( this.logStarted ) + '] ' + "Start log for "+this.fullName() + " (" + this.getFileName(this.file) +")";
					}
				}
			if( str ){
				str = this.errorToString( str );
				this.logSTRING += (this.logSTRING?'\n':'') + '[' + this.getFormattedDateTime( this.logStarted ) + '] ' + str;
				}
			if( write && this.logSTRING ){
				this.fileWriteLine( this.logFILE, this.logSTRING, {encoding: "utf-8"} );
				for( var i = 0; i < this.logFiles.length; i++ )
					if( this.logFiles[i].absoluteURI != this.logFILE.absoluteURI )
						this.fileWriteLine( this.logFiles[i], this.logSTRING, {encoding: "utf-8"} );
				this.logSTRING = "";
				}
			}catch(err){
				if( !this.logWriteError ){
					this.logWriteError = true;
					this.alertError(err);
					}
				};
			},
		logWriteError: false,
		//============= Script =============================
		file: false,
		getThisFile: function(){ try{ var res = app.activeScript || new File($.fileName); if( !res || res.constructor != File ) throw "error" else return res }catch(err){ return new File(err.fileName) } },
		fullName: function(){return this.name+' v.'+this.version},
		notShowErrorOnThisSession: false,
		alertError: function( errorObject, message ){
			if( errorObject.toString() == "Script finished" ) // если ошибка вызвана функцией exitScript() для завершения работы повторяем ошибку
				throw new Error( "Script finished" );
			try{
			var Str = errorObject+'\r';
			Str+='string: '+errorObject.line+'\r';
			if( message )
				Str+= 'Custom message: ' + message;
			this.LOG( Str, true ); // записывем с сохранением, поскольку ошибка может остановить работу скрипта
			// window
			if( this.notShowErrorOnThisSession || this.notShowAlert )
				return;
			Str+= '\r'+this.fullName();
			var LIB = this;
			var win = new Window("dialog", this.localize('Error'), undefined, );
			win.margins = 5;
			with(win){
				if( Str.split(/\r/).length > 20 ){
					win.eText = add( "edittext", undefined, Str, {multiline: 'true', } );
					win.eText.preferredSize = [400,150];
					}
				else{
					win.eText = add( "statictext", undefined, Str, {multiline: 'true', } );
					win.eText.justify = "left";
					win.eText.preferredSize = [400,150];
					}
				win.eText.maximumSize = [450,200];
				win.group = add( "group", undefined, undefined );
				win.group.alignment = ['fill', 'top'];
				win.group.orientation = 'row';
				with(win.group){
					win.group.cBox = add( "checkbox", undefined,  this.localize('Not show Error on this session') );
					win.group.cBox.alignment = ['left', 'center'];
					win.group.cBox.graphics.font = ScriptUI.newFont(win.group.cBox.graphics.font.name, win.group.cBox.graphics.font.style, 10);
					win.group.Exit = add( "button", undefined, 'Exit' );
					win.group.Exit.alignment = ['right', 'top'];
					win.group.Ok = add( "button", undefined, 'Ok' );
					win.group.Ok.alignment = ['right', 'top'];
					}
				}
			if( this.targetengine ) // пока не работает как надо
				win.group.Exit.enabled = false;
			else{
				win.group.Exit.onClick = function(){
					this.window.close();
					LIB.exitScript();
					}
				}
			win.group.Ok.onClick = function(){
				if( win.group.cBox.value )
					LIB.notShowErrorOnThisSession = true;
				this.window.close();
				}
			win.center();
			win.show();
			}catch(err){ if(!this.notShowErrorOnThisSession) this.alert(err) }
			},
		systemCheck: function(){
			var support = true; // default support
			var thisApp = this.appName+this.appVersion;
			var reg = new RegExp( this.appName, 'ig' );
			for( var name in this.supportApp ){
				support = false; // если объект содержит записи - включаем проверку
				if( reg.test(name) && (!this.supportApp[name] || this.appVersion >= this.supportApp[name] ) ){
					support = true;
					break;
					}
				}
			if( support && this.supportFS.length )
				for(var i=0;i<this.supportFS.length;i++){
					if(File.fs == this.supportFS[i]){
						support = true;
						break;
						}
					support = false;
					}
			if(support)
				return true;
			if( !this.notShowErrorOnThisSession )
				this.alert( this.localize('This version of a program is not supported') + ':\r'+this.fullName() + '\r\r======================\r'+(this.fullInfo?this.fullInfo():''), this.localize('Error'), true );
			return false;
			},
		exitScript: function( message ){
			message = message || "";
			if( message )
				this.alert( message );
			
			if( this.exitScriptWithFunction && this.exitScriptWithFunction.constructor == Function ){
				try{
					this.exitScriptWithFunction();
					}catch(err){
						this.LOG( err );
						}
				}
			this.LOG( '', true );
			this.saveXMLOptions();
			if( this.getAppName('indesign') )
				exit(0);
			else
				throw new Error( "Script finished" );
			},
		errorToString: function( err ){
			if( err && err.constructor == Error )
				return 'Error: ' + err + ' \rline: ' + err.line;
			return err;
			},
		alert: function( message, title, errorIcon ){ // message: string[, title: string][, errorIcon: bool=false])
			title = title || this.fullName();
			if( message == undefined )
				return;
			var error = message && message.constructor == Error;
			message = this.errorToString( message );
			this.LOG( message, error );
			if( !this.notShowAlert )
				alert( message, title, (errorIcon || error) );
			},
		//============= ExtendedScript =============================
		isNumber: function( value ){// возвращает true / false, value = Number or String
			if( value === undefined || value === null || value === '' )
				return false;
			return isFinite( value );
			},
		constructorName: function( value, constructorName ){// возвращает String: имя конструктора ('undefined' | 'null' | constructor.name) , если указан constructorName и он не совпадает с конструктором - возвращает ''
			if( constructorName && constructorName.constructor != String )
				constructorName = undefined;
			if( value == undefined ){
				if( constructorName ) 
					return /undefined/i.test(constructorName) ? 'undefined' : '';
				return 'undefined';
				}
			if( value == null ){
				if( constructorName ) 
					return /null/i.test(constructorName) ? 'null' : '';
				return 'null';
				}
			if( constructorName ) 
				return RegExp(value.constructor.name, 'i').test(constructorName) ? value.constructor.name : '';
			return value.constructor.name;
			},
		getWithPrefix: function( num, targetNum ){ // добавляет к числу префикс, возвращает строку. targetNum - число. под размер которого будет добавлен префикс
			if( this.isNumber(num) )
				num = +num;
			else
				return num;
			var level = targetNum ? Math.floor(targetNum).toString().length : 1; // округляем в меньшую сторону, переводим в строку и получаем её длинну. По умолчанию level = 1
			var res = num.toString();
			var length = Math.floor(num).toString().length; // округляем в меньшую сторону, переводим в строку и получаем её длинну
			while( length++ < level )
				res = '0' + res;
			return res;
			},
		getMonth: function( index, locale ){
			try{
			locale = locale || this.language;
			if( locale == 'ru' )
				return ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"][index];
			return ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][index];
			}catch(err){ return "[getMonth error: index = "+index+"]" }
			},
		getFormattedDateTime: function( date ) {
			date = date && date.constructor == Date ? date : new Date();
			// Gives us: Wed Jul 08 2009 14:05:44 GMT-0700
			// return: Jul 08 2009 14:05:44
			return date.toString().split(" ").slice(1,-1).join(" ");
			},
		//============= Messages =============================
		language: ( $.locale == 'ru_RU' ) ? 'ru' : 'en',
		localize: function( string ){
			return string ? ( this.messages[this.language][string] || string ) : '';
			},
		messages: {
			en: {},
			ru: {
				"Processing": 'Обработка',
				"Warning!": 'Внимание!',
				"Continue?": 'Продолжить?',
				"Preferences": 'Настройки',
				"Report": 'Отчет',
				"Error": 'Ошибка',
				"Do not show Error on this session": 'Больше не показывать',
				"This version of a program is not supported": 'Эта версия программы не поддерживается',
				"Error of data": 'Ошибка данных',
				"File not found": 'Файл не найден',
				"Folder not found": 'Папка не найдена',
				"Error writing file": 'Ошибка записи файла',
				"For MacOS: \ryou yourself must create alias in the folder:\r": 'Для MacOS: \rвы самостоятельно должны создать ярлык в папке:\r',
				"Progress": 'Выполнение',
				"Save as": 'Сохранить как',
//				"Error rename file": 'Ошибка переименования файла',
//				"Error deleting file": 'Ошибка удаления файла',
//				"Error load file": 'Ошибка загрузки данных',
				},
			},
		//============= Options =============================
		getDefaultXMLOptions: function(){
			return <{this.name} scriptVersion={this.version} libraryVersion={this.libraryVersion}>
					<user/>
				</{this.name}>;
			},
		XMLOptions: null,
		getXMLOptions: function(){
			if( !this.XMLOptions )
				this.initXMLOptions();
			return this.XMLOptions;
			},
		getUserXMLOptions: function(){
			return this.getXMLOptions().user;
			},
		initXMLOptions: function( fromFile ){
			// INI
			var xmlFile = fromFile ? fromFile : this.getPrefFile();
			if( xmlFile.exists ){
				// Err mess
				var errMess = 'Error XML options initialisation from file: ' + xmlFile.fsName +'\r';
				if( !this.XMLOptions )
					errMess += 'Loaded default options\r';
				errMess += 'Error message: ';
				
				var res = this.read_xml_file( xmlFile, true );
				if( res.constructor == Error )
					this.alertError( errMess + res );
				else if( res.name() != this.name )
					this.alertError( errMess + "incorrect name of root node: "+res.name() );
				else
					this.XMLOptions = res;
				}
			if( !this.XMLOptions ){
				xmlFile = this.getPrefFile();
				this.XMLOptions = this.getDefaultXMLOptions();
				}
			// EXE
			this.XMLOptions.@source_after_load = this.XMLOptions.toXMLString(); // запоминаем код исходника
			this.XMLOptions.@filePath = xmlFile.absoluteURI;
			this.XMLOptions.@fileName = xmlFile.displayName;
			
			// данные версий не обновляем - они будут давать информацию в каких условиях был создан файл настроек
			// обновляем данные версий
			// res.@version = this.version;
			// res.@libraryVersion = this.libraryVersion;
			},
		saveXMLOptions: function( toFile ){
			// INI
			var xmlOpts = this.getXMLOptions().copy(); // работаем с копией
			var xml_file = toFile ? toFile : new File( xmlOpts.@filePath.toString() );
			var SOURCE_AFTE_LOAD = xmlOpts.@source_after_load.toString(); // запоминаем исходный код
			// удаляем временные атрибуты
			delete xmlOpts.@filePath;
			delete xmlOpts.@fileName;
			delete xmlOpts.@source_after_load;
			// EXE
			if( !xml_file.exists || xmlOpts.toXMLString() != SOURCE_AFTE_LOAD )
				this.write_xml_file( xml_file, xmlOpts );
			},
		// ЗАКРЫТЫЕ
		getPrefFolder: function(){
			return this.folderCreate( new Folder(this.getWorkingDirectory().absoluteURI + '/' + this.name) );
			},
		workingDirectory: false,
		getWorkingDirectory: function(){
			if( this.workingDirectory && this.constructorName(this.workingDirectory, 'folder') )
				return this.workingDirectory;
			return new Folder( Folder.userData.absoluteURI + '/Adobe/Scripts' );
			},
		getPrefFile: function(){
			var prefFolder = this.getPrefFolder();
			if( !prefFolder )
				return false;
			return new File(prefFolder.absoluteURI+'/preferrences_v.'+this.version.toString().split('.')[0]+'_'+this.appName+this.appVersion+'.xml'); // файл настроек меняется только на уровне версий скрипта(т.е. подверсии используют один файл настроек)
			},
		resourcesFolder: function(){
			return this.folderCreate( new Folder(this.getPrefFolder().absoluteURI + '/resources') );
			},
		//============= JSON =============================
		objectToSource: function( object ){ // return string or ''
			if( this.JSON )
				return this.JSON.objectToSource( object );
			if( object == undefined || object == null || !Object.isValid(object) || object instanceof Array )
				return '';
//			return encodeURI(uneval(object));
			return uneval( object );
			},
		sourceToObject: function( string, returnError ){ // return Object or null, or Error (if returnError = true)
			if( !string || /^\s*?$/.test(string) )
				return null;
			if( this.JSON ){
				var res = this.JSON.sourceToObject( string );
				if( !res )
					return null;
				if( res.constructor == Error ){
					if( returnError )
						return res;
					this.alertError( res );
					return null;
					}
				return res;
				}
//			var source = decodeURI(string).replace(/[\n\r]/g,'\\n').replace(/[\t]/g,'\\t');
			try{
			var res = eval( '('+ string +')' );
			return res && Object.isValid(res) && res.constructor == Object ? res : null;
			}catch(err){
				if( returnError )
					return err;
				this.alertError( err );
				return null;
				}
			},
		//============= XML =============================
		write_xml_file: function( toFile, xml ){
			var str = "<?xml version='1.0' encoding='UTF-8'?>\
"+xml.toXMLString();
			this.fileWrite( toFile, str, {encoding: "UTF-8"} ); // opts = { encode: Bool, encoding: String }
			},
		read_xml_file: function( XMLFile, returnError ){ // return XML or false or Error (if returnError = true)
			try{
			if( !XMLFile.exists )
				throw new Error( 'XML file not found: ' + XMLFile.fsName );
			XMLFile.open('r');
			var res = XMLFile.read();
			XMLFile.close();
			if( !res )
				throw new Error( 'Error read XML file: ' + XMLFile.fsName );
			var myXML = new XML( res );
			if( !myXML )
				throw new Error( 'Error load XML from file: ' + XMLFile.fsName );
			return myXML;
			}catch(err){
				if( returnError )
					return err;
				this.alertError( err );
				return false;
				}
			},
		//============= file system =============================
		folderCreate: function( folder ){ // folder = Folder or String, return Folder / false
			if( !folder )
				return false;
			if( this.constructorName(folder, 'folder') ){
				}
			else if( this.constructorName(folder, 'string') )
				folder = new Folder( folder );
			else if( this.constructorName(folder, 'file') )
				folder = folder.parent;
			else return false;
			if( !folder.exists ){
				// функция взята из: BobsScriptLibrary
				var oFolder = new Folder( folder.absoluteURI ); // make a new folder object (copy) to play with
				var stk = new Array();
				while( !oFolder.exists ){ // we know this first one will not exist
					stk.push( oFolder ); // so push this folder onto the stack
					oFolder = new Folder( oFolder.path ); // and then check to see if the parent folder exists, if so, stop this loop
					}
				stk2 = new Array(); // this is to remove created folders if one of the subsequent folder creations fails - leave nothing behind
				while ( stk.length > 0 ){ // while there's still stuff in the stack
					oFolder = stk.pop(); // pop off the last one, create it, push it onto the error recovery stack if it works, if it doesn't unwind what we've done
					if( oFolder.create() )
						stk2.push( oFolder );
					else{
						while ( stk2.length > 0 )
							stk2.pop.remove();
						this.alertError( err );
						return false;
						} 
					}
				}
			return folder;
			},
		folderClear: function( folder ){ // return false / true
			var flag = true;
			try{
			var files = folder.getFiles();
			if( files.length )
				for( var i = files.length-1; i > -1; i-- ){
					if( files[i] instanceof Folder )
						flag = this.folderClear( files[i] );
					files[i].remove();
					}
			}catch(err){ flag = false; }
			finally{ return flag }
			},
		fileRead: function( file, opts ){ // opts = { decode: Bool }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			if(!file.exists){
				if( !this.notShowErrorOnThisSession ) 
					this.alert( 'fileRead:\n' + this.localize('File not found') + ':\n\n'+file.fsName, this.localize('Error'), true );
				return false;
				}
			var result = false;
			try{
			file.open( 'r' );
			var result = file.read();
			result = opts.decode ? decodeURI( result ) : result;
			}catch( err ){ 
				this.alertError( err ); 
				result = false; 
				}
			finally{
			file.close();
			}
			return result;
			},
		fileWrite: function( file, string, opts ){ // opts = { encode: Bool, encoding: String }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string = opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open("w");
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.write( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		fileWriteLine: function( file, string, opts ){
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string =  opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open('a');
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.writeln( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		adaptForFileName: function(str){
			return str.toString().replace(/[\r\n\t\\\/:*?"<>|]+/g, '_');
			},
		adaptFsNameForSave: function(fsName){
			return fsName.replace(/\\/g, '/').replace(/\'/g, '\\\'');
			},
		
		getFileName: function( file ){
			return file.fsName.split(/[\\\/]/).reverse()[0];
			// вариант 2 - без использования обратного слеша (js-код с обратным слешем не проходит через Bridge()):
			return decodeURI( file.absoluteURI ).split('/').reverse()[0]; 
			// вариант 3
			return file.fsName.substring( file.parent.fsName.length+1 );
			},
		getFileNameOnly: function( file ){ // Внимание: для получения имени папки не использовать
			if( file instanceof Folder )
				return this.getFileName( file ); 
			return this.getFileName( file ).split('.').slice(0,-1).join('.');
			// вариант 2
			return file.fsName.substring( file.parent.fsName.length+1, file.fsName.lastIndexOf('.') )
			},
		getFileExtention: function( file ){
			if( file instanceof File )
				return file.fsName.substring( file.fsName.lastIndexOf('.')+1 ).toLowerCase();
			return '';
			},
		getFileAlias: function(folder, file, create){
			try{
			var aliases = folder.getFiles(function(file){return file.alias});
			var fileLink = file.absoluteURI;
			for(var i = 0; i < aliases.length; i++)
				if(aliases[i].resolve().absoluteURI == fileLink)
					return aliases[i];
			if(create){
				if(!folder.exists)
					folder.create();
				if(File.fs == 'Macintosh'){
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('For MacOS: \ryou yourself must create alias in the folder:\r') + folder.fsName);
					return false;
					}
				var alias = new File(folder.absoluteURI + '/'  + this.getFileName(file));
				alias.createAlias(file);
				return alias;
				}
			return false;
			}catch(err){this.alertError(err)};
			},
		moveFile: function( FILE, FOLDER ){
			try{
			if( !FOLDER )
				return;
			var folder = this.folderCreate( FOLDER );
			if( !folder )
				throw new Error( 'script.moveFile function error: Folder not found: ' + FOLDER.toString() );
			if( FILE.copy(folder.absoluteURI +"/" + FILE.name) ){
				FILE.remove();
				return true;
				}
			}catch(err){this.alertError(err)};
			},
		getLastCreatedFile: function( folder, fileName, fileExtension ){ // возвращает самый новый файл среди найденных
			// folder: Folder or path
			// fileName: String. Часть имени файла (с начала).
			// fileExtension: String
			try{
			folder = new Folder(folder);
			if( !folder.exists ) return false;
			fileExtension = fileExtension ? '\.'+ fileExtension.replace(/^\./,'') : '';
			// последняя версия определяется по дате создания
			var files = folder.getFiles(function(thisFile) { return ( RegExp('^'+fileName+'.*?'+fileExtension+'$', '').test(thisFile.displayName) ) });
			files.sort( function(a,b){return (a.created > b.created)?1:0} );
			return files.length ? files[files.length-1] : false;
			}catch(err){this.alertError( err ); return false;}
			},
		//============= application data =============================
		appName: app.name.replace('Adobe ',''),
		getAppName: function( str ){ var name = app.name.split(' ').reverse()[0].toLowerCase(); return arguments.length ? (RegExp(name,'ig').test(arguments[0])?name:false) : name; },// если указан str - возвращает результат поиска в строке имени программы
		appVersion: parseFloat( app.version ),
		appVersionCS: function(){
			switch( this.appName ){
				case 'InDesign':
				return this.appVersion - 2;
				case 'Photoshop':
				return this.appVersion - 7;
				case 'Illustrator':
				return this.appVersion - 10;
				default:
				return 0;
				}
			},
		getStartupFolder: function(){
			var folder = new Folder((app.filePath || app.path) + ((this.appName == 'InDesign')?'/Scripts':'') + '/Startup Scripts');
			if(!folder.exists)
				folder.create();
			return folder;
			},
		getInDesignIcon: function( iconCataloquePath ){
			if( iconCataloquePath && (this.getAppName('indesign')||BridgeTalk.getStatus('indesign')!='ISNOTINSTALLED') && this.appVersionCS() >= 5 ){
				if( File.fs == 'Macintosh' )
					iconCataloquePath = iconCataloquePath.replace( /\(([^()]+) Resources\)/, '$1.InDesignPlugin/Versions/A/Resources' );
				if( new File(iconCataloquePath).exists )
					return ScriptUI.newImage( iconCataloquePath );
				// если это неполный путь из каталога - наращиваем
				var app_path = this.getAppName('indesign') ? app.filePath : BridgeTalk.getAppPath('indesign').replace(/[^\\\/]+$/,'');
				iconCataloquePath = app_path + '/Plug-Ins/' + iconCataloquePath;
			//	$.writeln( iconCataloquePath );
				if( new File(iconCataloquePath).exists )
					return ScriptUI.newImage( iconCataloquePath );
				}
			return false;
			},
		getInDesignIconShortPath: function( pathOrFileOrScriptUIImage ){
			if( pathOrFileOrScriptUIImage.constructor == String )
				var icon_file = new File( pathOrFileOrScriptUIImage );
			else if( pathOrFileOrScriptUIImage.constructor == File )
				var icon_file = pathOrFileOrScriptUIImage;
			else if( pathOrFileOrScriptUIImage.constructor == UIImage )
				var icon_file = new File( pathOrFileOrScriptUIImage.pathname );
			
			if( this.getFileExtention(icon_file) == 'idrc' && icon_file.exists )
				return icon_file.fsName.replace( /\\/g, '/' ).replace( /^.+\/Plug-Ins\//, '' );
			
			return icon_file.fsName;
			},
		//============= scriptUI =============================
		images: [],
		writeImage: function(codeStr, name){
			
			var folder = this.resourcesFolder();
			if(!folder.exists)
				folder.create();
			var pngFile = new File(folder.absoluteURI + '/' + name + '.png');
			if(!pngFile.exists){
				pngFile.encoding = "BINARY";
				if(!this.fileWrite(pngFile, codeStr)){
					this.images[name] = false;
					return false;
					}
				}
			this.images[name] = ScriptUI.newImage(pngFile.absoluteURI);
			
//			this.images[name] = ScriptUI.newImage( codeStr );
			return this.images[name];
			},
		getUiObjectIndex: function(uiObject){
			try{
			for(var i = 0; i < uiObject.parent.children.length; i++)
				if(uiObject.parent.children[i] == uiObject)
					return i;
			}catch(err){this.alertError(err)};
			},
		resizeWindow: function( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
			try{
			var size = [0,0];
			size[sizeIndex] = value;
			var location = [window.location[0], window.location[1]];
			var bounds = [window.bounds[0], window.bounds[1], window.bounds[2], window.bounds[3]];
			window.location = location;
			window.bounds = [bounds[0], bounds[1], bounds[2]+size[0], bounds[3]+size[1]];
			window.location = location;
			}catch(err){ this.alertError( err ); }
			},
		confirm: function( message, opts ){ // return  false / true/undefined. opts = {title: str, multiline: bool, withUndefined: bool}
			opts = opts || {};
			var result = opts.withUndefined ? undefined : false;
			var win = new Window( 'dialog', opts.title || '' );
			win.alignChildren = 'right';
			win.margins = 5;
			win.spacing = 5;
			with(win){
				if( message )
					win.Text = add('statictext', undefined, message, {multiline:(opts.multiline?true:false)});
				win.Grp = add('group');
				win.Grp.orientation = 'row';
				win.Grp.spacing = 5;
				with(win.Grp){
					if( opts.withUndefined )
						win.Grp.Cancel = add( 'button', undefined, 'Cancel' );
					win.Grp.no = add('button', undefined, 'No');
					win.Grp.ok = add('button', undefined, 'OK');
					}
				}
			if( opts.withUndefined ){
				win.Grp.Cancel.onClick = function(){
					result = undefined;
					this.window.close();
					}
				}
			win.Grp.no.onClick = function(){
				result = false;
				this.window.close();
				}
			win.Grp.ok.onClick = function(){
				result = true;
				this.window.close();
				}
			win.defaultElement = win.Grp.ok;
			win.center();
			win.show();
			return result;
			},
		getReportWindow: function( reportText, tittle, reportName, width ){//ОКНО ВЫВОДА РЕЗУЛЬТАТОВ
			tittle = tittle || '';
			width = width || 400;
			var _height = new String( reportText ).split('\r').length;
			var resizeable = this.hasOwnProperty('addDynamicObject');
			if( _height == 1 ) _height = 22;
			else _height = ( _height < 20 ) ? 15*_height : 300;
			var winReport = new Window( 'dialog', tittle, undefined, {resizeable: resizeable} );
			winReport.alignChildren = 'left';
			winReport.margins = 5;
			winReport.spacing = 10;
			with(winReport){
				if( reportName ){
					winReport.Name = add('statictext', undefined, reportName, {multiline:true});
					winReport.Name.preferredSize = [ width, winReport.Name.preferredSize[1] ];
					}
				winReport.Text = add('edittext', undefined, reportText, {multiline:true, readonly: ( File.fs == 'Windows' )});
				winReport.Text.alignment = ["fill", "fill"];
				winReport.Text.preferredSize = [ width, _height ];
				
				winReport.ok = add('button', undefined, 'OK');
				winReport.ok.alignment = 'center';
				};
			winReport.ok.onClick = function(){
				this.window.close();
				}
			//====================== RESIZE
			if( resizeable ){
				script.addDynamicObject( { obj: winReport.Text, moveCoefs: false, resizeCoefs: [1,1], isSeparator: false, windowKeyRestore: script.name+'_ReportWindow' } );
				script.addDynamicObject( { obj: winReport.ok, moveCoefs: ['center',1], resizeCoefs: false, isSeparator: false } );
				if( winReport.Name )
					script.addDynamicObject( { obj: winReport.Name, moveCoefs: false, resizeCoefs: [1,0], isSeparator: false } );
				}
			else{
				winReport.Text.minimumSize = [ width, _height ];
				winReport.ok.minimumSize = winReport.ok.maximumSize = [100, 22 ];
				
				winReport.onResizing = function() {this.layout.resize()}
				winReport.onShow = function(){
					this.layout.layout();
					this.minimumSize = this.preferredSize;
					}
				}

			winReport.center();
			winReport.show();
			},
		getProgressBar: function( container, maxValue, size, location, reverse ){//возвращает progressbar с ф-цией setValue( [num] )
			/*
			Note: in scripts that use progress bars, you cannot set
			app.scriptPreferences.enableRedraw to false. If you do, the progress
			bar doesn't display correctly. This is on Macs only.
			*/
			if( /indesign/i.test(app.name) )
				app.scriptPreferences.enableRedraw = true;
			
			size = size || [200, 8];
			location = location || [0,0];
			if( File.fs == '_Macintosh' ){ // отключено
				// Самодельный прогрессбар
				var pBar = container.add('group', [location[0], location[1], location[0]+size[0], location[1]+size[1]]);
				pBar.visible = false;
				pBar.graphics.backgroundColor =
				pBar.graphics.disabledBackgroundColor = // в окне, у которого нет фокуса - ничего не обновляется, disabledBackgroundColor не помогает
					pBar.graphics.newBrush(pBar.graphics.BrushType.SOLID_COLOR, [0/255, 0/255, 255/255, 1]);
				pBar.step = pBar.size[0]/maxValue;
				pBar.value = 0;
				pBar.setValue = function( num ){
					num = num || 1;
					if( !this.value || this.value >= maxValue ){
						this.size = [0, this.size[1]];
						this.visible = true;
						this.value = 0;
						}
					this.value += num;
					this.size = [this.step*this.value, this.size[1]];
					}
				return pBar;
				}
			if( reverse ){
				var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], maxValue, maxValue);
				pBar.setValue = function( num ){
					num = num || 1;
					if( this.value >= maxValue ) this.value = maxValue;
					this.value -= num;
					};
				return pBar;
				}
			var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], 0, maxValue);
			pBar.setValue = function( num ){
				num = num || 1;
				if( (this.value + num) > maxValue ){
					num = (maxValue - this.value) || 1;
					this.value = 0;
					}
				this.value += num;
				};
			return pBar;
			},
		getProgressWindow: function( maxValue, title, reverse ){//return palette{ setValue: function( [num] ) }
			var LIB = this;
			title = title || this.localize('Progress');
			var myProgressPanel = new Window('palette', title);
			myProgressPanel.progressBar = this.getProgressBar( myProgressPanel, maxValue, undefined, undefined, reverse );
			myProgressPanel.setValue = function( num ){
				this.progressBar.setValue( num );
				}
			myProgressPanel.addProgressBar = function( maxValue, reverse ){
				var pBar = LIB.getProgressBar( this, maxValue, undefined, undefined, reverse ); // with 
				pBar.removeBar = function(){
					var win = this.window;
					win.remove( this );
					win.layout.layout( true );
					}
				this.layout.layout( true );
				return pBar;// return  ProgressBar with functs setValue(num) and removeBar()
				}
			myProgressPanel.center();
			return myProgressPanel;
			},
		addGroupListener: function( prefs ){ // prefs = {objs: Array of UIObjects, listener: function( event ), onChangingMode: Bool }
			if( !prefs || !prefs.objs || !prefs.objs || !prefs.listener || prefs.listener.constructor != Function )
				return;
			if( prefs.objs.constructor != Array )
				prefs.objs = [prefs.objs];
			for( var i = 0; i <prefs.objs.length; i++ ){
				if( prefs.objs[i].hasOwnProperty('margins') ){// обработчики для содержимого контейнеров
					if( prefs.onChangingMode )
						prefs.objs[i].addEventListener( 'changing', prefs.listener );
					else{
						prefs.objs[i].addEventListener( 'click', prefs.listener );
						prefs.objs[i].addEventListener( 'change', prefs.listener );
						}
					continue;
					}
				switch( prefs.objs[i].type ){
					case "dropdownlist":
					case "listbox":
					case "treeview":
					case "edittext":
					case "scrollbar":
					case "slider":
						if( prefs.onChangingMode )
							prefs.objs[i].addEventListener( 'changing', prefs.listener );
						else
							prefs.objs[i].addEventListener( 'change', prefs.listener );
					break;
					case "checkbox":
					case "radiobutton":
					case "button":
					case "iconbutton":
						prefs.objs[i].addEventListener( 'click', prefs.listener );
					}
				}
			},
		}
		return scriptLIB;
		};
	}
function extension_scriptInfo( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'scriptInfo';
	var version = 1.22;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.messages.en.info = 'Info';
	script.messages.en.script = 'Script';
	script.messages.en.help = 'Help';
	script.messages.en.system = 'System';
	script.messages.ru.info = 'Информация';
	script.messages.ru.script = 'Скрипт';
	script.messages.ru.help = 'Помощь';
	script.messages.ru.system = 'Система';
	script.supportInfo = function(){
		try{
		var arr_supApps = [];
		for( var name in this.supportApp )
			arr_supApps.push( name + (this.supportApp[name] ? ' ' + this.supportApp[name] + ' and late' : '') );
		var supportFS = this.supportFS.length ? this.supportApp.length : ['Windows','Macintosh'];
		return arr_supApps.join(' / ') + ' // ' + supportFS.join('/');
		}catch(err){this.alertError(err)}
		}
	script.fullInfo = function(){
		return this.fullName()+'\r'+
			'for '+this.supportInfo()+'\r\r'+
			'script of '+this.autor+', '+this.release+'\r'+
			this.mail+'\r'+
			this.sites.join('\r');
		}
	script.getWinInfo = function( addInfo, help ){ // addInfo - additional information about the script
		try{
		addInfo = addInfo ? '\r\r'+addInfo : '';
		help = help || '';
		var thisSite = ( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 ) ? false : this.sites[0];
		var addScriptInfo = function( container ){
			var item;
			with(container){
				item = add('statictext', undefined, container.window.core.fullInfo() + addInfo , {multiline: true});
				
				var buts = add('group');
				buts.orientation = 'row';
				buts.alignment = 'right';
				buts.margins = [0,10,0,10];
				if( thisSite ){
					var site = buts.add('button', undefined, thisSite);
					site.onClick = function(){
						this.window.core.connectToSite();
						this.window.close();
						}
					}
				}
			}
		var addHelpInfo = function( container ){
			var item = container.add('statictext', undefined, help, {multiline: true, scrolling: true });
			item.preferredSize = [350,300];
			}
		var addSystemInfo = function( container ){
			container.add('statictext', undefined, container.window.core.getSystemInfo(), {multiline: true});
			var item = container.add( "button", undefined, 'working directory' );
			item.alignment = ['left', 'top'];
			item.onClick = function(){
			var dir = script.getWorkingDirectory();
			if( dir )
				dir.execute();
			}
			}
		var winInfo = new Window( 'dialog', this.localize('info') );
		winInfo.core = this;
		winInfo.preferredSize = [400,10];
		winInfo.alignChildren = 'fill';
		winInfo.margins = 5;
		winInfo.spacing = 5;
		if(this.appVersionCS() > 3){//CS4 и старше
			with(winInfo){
				winInfo.tPnl = add('tabbedpanel');
				with(winInfo.tPnl){
					winInfo.tPnl.script = add( 'tab', undefined, this.localize('script') );
					winInfo.tPnl.script.orientation = 'column';
					winInfo.tPnl.script.alignChildren = 'fill';
					addScriptInfo( winInfo.tPnl.script );
					
					if( help ){
						winInfo.tPnl.help = add( 'tab', undefined, this.localize('help') );
						winInfo.tPnl.help.orientation = 'column';
						winInfo.tPnl.help.alignChildren = 'fill';
						addHelpInfo( winInfo.tPnl.help );
						}
					
					winInfo.tPnl.system = add( 'tab', undefined, this.localize('system') );
					winInfo.tPnl.system.orientation = 'column';
					winInfo.tPnl.system.alignChildren = 'fill';
					addSystemInfo( winInfo.tPnl.system );
					}
				}
			}
		else{//CS3
			addScriptInfo( winInfo );
			winInfo.tPnl = winInfo.add( 'panel', undefined, this.localize('system') );
			winInfo.tPnl.alignChildren = 'fill';
			addHelpInfo( winInfo.tPnl );
			addSystemInfo( winInfo.tPnl );
			}
		winInfo.ok = winInfo.add('button', undefined, "OK");
		winInfo.ok.alignment = 'center';
		winInfo.ok.onClick = function(){
			this.window.close();
			}
		winInfo.center();
		winInfo.show();
		}catch(err){this.alertError(err)};
		}
	script.getSystemInfo = function(){
		var str = '';
		try{
		str+=$.os+'\r';
		str+=this.appName+' '+this.appVersion+'\r';
		str+='Language: '+$.locale+'\r';
		str+='ScriptUI: '+ScriptUI.version+'\r';
		str+= '\r' + 'scriptLibrary: '+this.libraryVersion+'\r'
		if( $.fileName && File($.fileName).exists )
			str+= '('+File($.fileName).fsName+')'+'\r';
		if( this.extensions.toSource() != '({})' ){
			str += 'scriptExtensions:\r';
			for( var name in this.extensions )
				str += '   ' + name + ': ' + this.extensions[name].version + (this.extensions[name].description ? ' ('+this.extensions[name].description+')':'') + '\r';
			}
		return str;
		}catch(err){ return str }
		}
	script.connectToSite = function(){
		if( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 )
			return;
		var thisSite = this.sites[0];
		var urlFile = File(Folder.temp.absoluteURI + '/'+this.adaptForFileName(thisSite)+'.url');
		if(!urlFile.exists)
			this.fileWrite( urlFile, '[DEFAULT]\rBASEURL=http://'+thisSite+'/\r[InternetShortcut]\rURL=http://'+thisSite+'/' );
		try{
			urlFile.execute();
			} catch(err) {this.alertError(err)}
		}
	}
function extension_customDraw( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'customDraw';
	var version = 1.21;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.getCustomDraw = function( uiObject, args ){// args = { text: 'myButton', font: 'Tahoma', style: 'Bold', size: 12, textRGB: [0,0,0], bgRGB: [0,0,0], uiImage: UIImage } - добавление текста в элемент scriptUI (напр., для добавления текста в iconbutton) и раскраска элемента
		// v.2
		if( uiObject.constructor == Array ){
			for(var i = 0; i < uiObject.length; i++)
				this.getCustomDraw( uiObject[i], args );
//				arguments.callee( uiObject[i], args );
			return;
			}
		try{
		if( !args )//обнуление, убирает ранее установленное форм-ние (текст и цвет)
			args = uiObject.image ? {uiImage: uiObject.image} : {};
		
		if( args.text )
			this.addFont( uiObject, args );
		
		uiObject.onDraw = function(){
			try{
			this.graphics.drawOSControl();
			if( args.bgRGB ){
				this.graphics.rectPath( 0, 0, this.size[0], this.size[1] );
				this.graphics.fillPath( this.graphics.newBrush( this.graphics.BrushType.SOLID_COLOR, [args.bgRGB[0]/255, args.bgRGB[1]/255, args.bgRGB[2]/255, 0.5] ) );
				}
			if( args.uiImage ){
				if( uiObject.hasOwnProperty('image') )
					uiObject.image = args.uiImage;
				
				var uiObject_size = this.size ? this.size : this.preferredSize;
				if( args.uiImage.size[0] <= uiObject_size[0] && args.uiImage.size[1] <= uiObject_size[1] ){
					var wh = [args.uiImage.size[0],args.uiImage.size[1]];
					}
				else{ // если иконка  не вписывается в габариты
					// коэфициент уменьшения
					var k = Math.min(uiObject_size[0]/uiObject.image.size[0], uiObject_size[1]/uiObject.image.size[1]);
					var wh = [k*uiObject_size[0],k*uiObject_size[1]];
				//	$.writeln( wh.toString() );
					}
				var xy = [ (uiObject_size[0]-wh[0])/2, (uiObject_size[1]-wh[1])/2 ];
				this.graphics.drawImage(
					args.uiImage,
					xy[0],
					xy[1],
					wh[0],
					wh[1]
					);
				}
			if( args.text ){
				args.textRGB = args.textRGB || [0,0,0];//по умолчанию - Black
				var textSize = this.graphics.measureString( args.text );
				var x = Math.max(0, (this.size[0] - textSize[0])/2);
				var y = Math.max(0, (this.size[1] - textSize[1])/2);
				this.graphics.drawString( args.text, this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, [args.textRGB[0]/255, args.textRGB[1]/255, args.textRGB[2]/255, 1], 1 ), x, y);
				}
			}catch(err){ throw err } //alert( err + ', line ' + err.line ) }
			};
		uiObject.enabled = !uiObject.enabled;
		uiObject.enabled = !uiObject.enabled;
		}catch(err){this.alertError(err)};
		}
	script.addFont = function( uiObject, args ){// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Regular, Bold, Italic, Bolditalic)
		if( args ){
			try{
			if( args.font || args.style || args.size ){
				args.font = args.font || uiObject.graphics.font.name;
				args.style = args.style || uiObject.graphics.font.style;
				args.size = args.size || uiObject.graphics.font.size;
				return uiObject.graphics.font = ScriptUI.newFont(args.font, args.style, args.size);
				}
			else if( args.graphics && args.graphics.font )//если через args передан uiobject
				return uiObject.graphics.font = args.graphics.font;
			}catch(err){}
			}
		try{ return uiObject.graphics.font }catch(err){ return false }
		}
	script.addColor = function( uiObject, type, RGB, opacity ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject or ScriptUIBrush/Pen. Return uiObject.graphics.[type]Color or false
		opacity = opacity && opacity <= 1 ? opacity : 1;
		if( RGB ){
			try{
			if( !type )
				return uiObject.graphics.backgroundColor = 
					RGB instanceof Array ? 
						uiObject.graphics.newBrush(uiObject.graphics.BrushType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, opacity]) :
/*						RGB instanceof ScriptUIBrush ? 
							RGB : 
							RGB.graphics.backgroundColor ?
								RGB.graphics.backgroundColor : */
								uiObject.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor = 
					RGB instanceof Array ? 
						uiObject.graphics.newPen(uiObject.graphics.PenType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, opacity], 2) :
/*						RGB instanceof ScriptUIPen ? 
							RGB : 
							RGB.graphics.foregroundColor ? 
								RGB.graphics.foregroundColor : */
								uiObject.graphics.foregroundColor;
			}catch(err){}
			}
		//если не указан RGB - просто возвращаем color объекта
		try{ 
			if( !type )
				return uiObject.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor;
			}catch(err){ return false }
		}
	script.getRGB = function( uiObject, type ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor)
		var color = this.addColor( uiObject, type );
		if( color )
			return [Math.round(color[0]*255), Math.round(color[1]*255), Math.round(color[2]*255)];
		}
	}
function extension_contextMenu( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'contextMenu';
	var version = 1.41;
	var script = scriptLibrary;
	if( script.appVersionCS() < 4 )
		return script.alert( 'This version of program not support: '+script.appName+' CS'+ script.appVersionCS(), 'extension_contextMenu', true );
	
	script.extensions[name] = {version: version};
	
	script.trueFunction = function(){ return true };
	script.falseFunction = function(){ return false };
	script.separatorMenuItem = {}; // separator with line
	//=================================
	script.addContextMenu = function( opts ){
		// opts = { target: uiObject, menuItems: Array of menuItems, palette: bool (only for targetengine 'session' and Windows), preAction: function(EVENT){return false/true} }, optionsObject = {title:"", titleImage: ScriptUIImage}
		// menuItem = { name: "", marker: "", action: function( EVENT, listItem ), visible: function(EVENT, listItem){return true/false} or true, enabled: function(EVENT, listItem){return true/false} or true, notCloseMenu: bool, image: ScriptUIImage, textRGB: [r,g,b] }
		// окно контекстного меню имеет методы:
		// refreshItem( item ),
		// доступ к окну конт. меню можно получить через свойство listItem.CM
		if( !opts )
			return;
		
		var uiObject = opts.target;
		var items = opts.menuItems;
		var paletteType = ( (opts.palette || this.targetengine) );//&& File.fs == 'Windows');
		if( paletteType && File.fs == 'Macintosh' && /illustrator/i.test(app.name) )
			paletteType = false;
		var preAction = opts.preAction && opts.preAction.constructor == Function ? opts.preAction : script.trueFunction;
		if( !items || items.constructor != Array )
			return;
		
		var imagesStatus; // присутствует ли графика
		var maxString = "____________"; // ширина меню
		
		for( var i = 0; i < items.length; i++ ){
			if( items[i] == script.separatorMenuItem )
				continue;
			
			if( !items[i].action || items[i].action.constructor != Function )
				items[i].action = false; // элементы без ф-ции action будут отображаться как неактивные
			
			if( !items[i].visible )
				items[i].visible = script.falseFunction;
			else if( items[i].visible===true )
				items[i].visible = script.trueFunction;
			else if( items[i].visible.constructor == Function ){
				}
			else
				items[i].visible = script.falseFunction;
			
			if( !items[i].enabled )
				items[i].enabled = script.falseFunction;
			else if( items[i].enabled===true )
				items[i].enabled = script.trueFunction;
			else if( items[i].enabled.constructor == Function ){
				}
			else
				items[i].enabled = script.falseFunction;
			
			if( items[i].image && items[i].image.constructor == ScriptUIImage )
				imagesStatus = true;
			
			if( items[i].name && maxString.length < items[i].name.length )
				maxString = items[i].name;
			}
		
		if( !paletteType ){
			items.push( script.separatorMenuItem );
			items.push( { name: "Close menu", action: function(){}, visible: script.trueFunction, enabled: script.trueFunction} );
//			if( imagesStatus ){
//				var icon = script.getInDesignIcon( 'Workgroup/(Workgroup UI Resources)/idrc_PNGA/4518.idrc' );
//				if( icon )
//					elements.Close.image = icon;
//				}
			}
		uiObject.addEventListener( "mousedown", contextMenu );
		
		function contextMenu(e){
			if( e.button != 2 ) // only right button
				return;
			if( !preAction(e) )
				return;
			// копируем объект события, поскольку сам оригинал передавать в другие ф-ции нельзя
			var EVENT = {};
			for( var i in e )
				EVENT[i] = e[i];
			e.preventDefault();
			e.target.active = true;// переводим фокус на цель
			
			var CM = new Window (paletteType?"palette":"dialog", undefined, undefined, {borderless: paletteType});
			if( paletteType )
				CM.addEventListener( "blur", function(){CM.close(); delete CM} );
			
			CM.margins = 0;
			CM.opacity = 0.9;
			
			var INDENT, IMAGE_SIZE, FULL_HEIGHT; // для ini_contextMenu_indesign()
			
			var TEXT_SIZE = CM.graphics.measureString( maxString ); // [width, height]
			
			
			if( /indesign/i.test(app.name) )
				ini_contextMenu_indesign();
			else
				ini_contextMenu_standart();
			
			// ==
			CM.location = [
				$.screens[0].right < e.screenX+CM.BOX.preferredSize[0] ? e.screenX - CM.BOX.preferredSize[0] : e.screenX, 
				$.screens[0].bottom < e.screenY+CM.BOX.preferredSize[1] ? e.screenY - CM.BOX.preferredSize[1] : e.screenY, 
				];
			
			CM.active = true;
			CM.show();
			
			// ==============================================================
			// на основе "подсветка контекстного меню - 4"
			function ini_contextMenu_indesign(){
				try{
				
				CM.BOX = CM.add( 'panel' );
				CM.BOX.spacing = CM.BOX.margins = 0;
				CM.BOX.alignChildren = ['fill','top'];
				
				INDENT = imagesStatus ? 30 : 5;
				IMAGE_SIZE = [22,22]; // размер иконки элемента меню
				
				// для работы позиционирования меню
				CM.BOX.preferredSize.width = INDENT+TEXT_SIZE[0]+5;
				FULL_HEIGHT = 0;
				
				// добавляем
				for( i = 0; i < items.length; i++ )
					contextMenu_indesign_addItem( items[i] );
				
				CM.BOX.preferredSize.height = FULL_HEIGHT;
				
				CM.refreshItem = function( item ){
					contextMenu_indesign_drawItem( item );
					}
				
				}catch(err){ script.alertError( err ); }
				}
			function contextMenu_indesign_addItem( menuItem ){
				try{
				// menuItem = { name: "", id: "", action: function( EVENT, listItem ), visible: function(EVENT, listItem){return true/false} or true, enabled: function(EVENT, listItem){return true/false} or true, notCloseMenu: bool, image: ScriptUIImage }
				
				if( menuItem == script.separatorMenuItem ){
					if( CM.BOX.children.length && CM.BOX.children[CM.BOX.children.length-1].type != 'panel' ){
						FULL_HEIGHT += 2;
						return CM.BOX.add( "panel" ).preferredSize.height = 2;
						}
					return;
					}
				
				if( !menuItem.visible(EVENT, menuItem) )
					return;
				
				var item = CM.BOX.add( "image" );
				item.preferredSize.height = 25;
				FULL_HEIGHT += 25;
				
				// поскольку в standart-варианте элементами меню выступают объекты ListItem, которые не имеют св-ва window
				// то чтобы не было путаницы - доступ к окну меню реализовываем через св-во .CM
				item.CM = CM;
				item.menuItem = menuItem;
				
				contextMenu_indesign_drawItem( item );
				
				// добавляем событие клика
				if( menuItem.action ){
					item.addEventListener(
						'click',
						function( e ){
							try{
							var item = e.target;
							if( !item.menuItem.notCloseMenu ){
								this.window.close();
								if( paletteType )
									delete CM;
								}
							item.menuItem.action(EVENT, item)
							}catch(err){
								script.alertError( err );
								this.window.close();
								if( paletteType )
									delete CM;
								}
							},
						false
						);
					}
				}catch(err){ script.alertError( err ); }
				}
			function contextMenu_indesign_drawItem( item ){
				try{
				if( !item )
					return;
				var custom_color = item.menuItem.textRGB ? [item.menuItem.textRGB[0]/255, item.menuItem.textRGB[1]/255,item.menuItem.textRGB[2]/255] : undefined;
				
				item._text = {
					text: item.menuItem.name,
					x: INDENT, // отступ
					y: Math.max(0, (item.preferredSize[1] - TEXT_SIZE[1])/2) // по центру
					};
				
				// вычисляем данные для отрисовки картинки
				if( item.menuItem.image ){
					// запоминаем 
					item._image = {};
					item._image.image = item.menuItem.image;
					// коэфициент
					var k = Math.min(IMAGE_SIZE[0]/item._image.image.size[0], IMAGE_SIZE[1]/item._image.image.size[1]);
					// Resize proportionally:
					item._image.wh = [k*item._image.image.size[0],k*item._image.image.size[1]];
					// Left:
					item._image.xy = [ 0, (IMAGE_SIZE[1]-item._image.wh[1])/2 ]; // Center: [ (WH[0]-wh[0])/2, (WH[1]-wh[1])/2 ];
					}
				
				var is_active = item.menuItem.action && item.menuItem.enabled( EVENT, item.menuItem );
				
				if( is_active ){ // подсветка - только для активных элементов
					item.addEventListener( 
						'mouseover', 
						function( e ){
							try{
							var item = e.target;
							if( !item.enabled )
								return;
							item.onDraw = function(){
								this.graphics.drawOSControl();
								// Back
								this.graphics.rectPath( 0, 0, this.size[0], this.size[1] );
								this.graphics.fillPath( this.graphics.newBrush( this.graphics.BrushType.SOLID_COLOR, [0.5, 0.5, 0.5, 0.5] ) );
								// IMAGE
								if( this._image )
									this.graphics.drawImage(
										this._image.image,
										this._image.xy[0],
										this._image.xy[1],
										this._image.wh[0],
										this._image.wh[1]
										);
								// TEXT
								try{ // в Photoshop здесь выскакивает ошибка actionScript, отрисовка проходит частично - не далее примерно 15-го знака
								this.graphics.drawString(
									this._text.text,
									this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, (custom_color?custom_color:[0,0,0]), 1 ),
									this._text.x,
									this._text.y 
									);
									}catch(err){ } //alert( err + ', line ' + err.line ) }
								};
							//активируем изменения
							item.enabled = false;
							item.enabled = true;
							}catch(err){ script.alertError( err ) }
							}, 
						false 
						);
					}
					
				item.addEventListener( 
					'mouseout', 
					function( e ){
						try{
						var item = e.target;
						if( !item.enabled )
							return;
						item.onDraw = function(){
							this.graphics.drawOSControl();
							// IMAGE
							if( this._image )
								this.graphics.drawImage(
									this._image.image,
									this._image.xy[0],
									this._image.xy[1],
									this._image.wh[0],
									this._image.wh[1]
									);
							// TEXT
							try{ // в Photoshop здесь выскакивает ошибка actionScript, отрисовка проходит частично - не далее примерно 15-го знака
							this.graphics.drawString(
								this._text.text,
								this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, (custom_color?custom_color:(is_active?[0,0,0]:[0.5,0.5,0.5])), 1 ),
								this._text.x,
								this._text.y 
								);
								}catch(err){}// alert( err + ', line ' + err.line ) }
							};
						//активируем изменения
						item.enabled = false;
						item.enabled = true;
						}catch(err){ script.alertError( err ) }
						}, 
					false 
					);
				
				// отрисовываем через вызов события mouseout
				var event = ScriptUI.events.createEvent( 'MouseEvent' );
				event.initMouseEvent( 'mouseout' );
				item.dispatchEvent( event );
				
				}catch(err){ script.alertError( err ); }
				}
			// ==============================================================
			function ini_contextMenu_standart(){
				try{
				var width = CM.graphics.measureString(maxString)[0]+(File.fs=='Windows'?10:50);
				var itemHeight = 18;
				var line = maxString.replace( /./g,'_' );
				if( imagesStatus ){
					CM.BOX = CM.add('listbox', undefined, undefined, {numberOfColumns: 2, showHeaders: false, columnWidths: [25, width]});
					var item;
					for( var i = 0; i < items.length; i++ ){
						if( items[i] == script.separatorMenuItem ){
							if( CM.BOX.items.length && CM.BOX.items[CM.BOX.items.length-1].subItems[0].text != line ){
								item = CM.BOX.add('item', '');
								item.subItems[0].text = line;
								item.enabled = false;
								}
							continue;
							}
						if( !items[i].visible(EVENT, items[i]) )
							continue;
							item = CM.BOX.add('item', '');
						if( items[i].image ){
							item.image = items[i].image;
	//						if( item.image.size[1] > itemHeight )
	//							itemHeight = item.image.size[1];
							}
						item.subItems[0].text = items[i].name;
						if( !items[i].action || !items[i].enabled(EVENT, items[i]) )
							item.enabled = false;
						// поскольку в standart-варианте элементами меню выступают объекты ListItem, которые не имеют св-ва window
						// то чтобы не было путаницы - доступ к окну меню реализовываем через св-во .CM
						item.CM = CM;
						item.menuItem = items[i];
						}
					width += 30;
					}
				else{
					var this_names = [];
					var this_items = [];
					for( var i = 0; i < items.length; i++ ){
						if( items[i] == script.separatorMenuItem ){
							if( this_names.length && this_names[this_names.length-1] != line ){
								this_names.push(line);
								this_items.push( false );
								}
							continue;
							}
						if( !items[i].visible(EVENT, items[i]) )
							continue;
						this_names.push(items[i].name);
						this_items.push(items[i]);
						}
					CM.BOX = CM.add('listbox', undefined, this_names);// , {items: this_names});
					for( var i = 0; i < this_items.length; i++ ){
						if( !this_items[i] || !this_items[i].action )
							CM.BOX.items[i].enabled = false;
						CM.BOX.items[i].menuItem = this_items[i];
						CM.BOX.items[i].CM = CM;
						}
					}
				CM.BOX.itemSize = [undefined, itemHeight];
				CM.BOX.preferredSize = [width, this_names.length*itemHeight+10+(File.fs=='Windows'?0:20)];
				CM.BOX.onChange = function(){
					var listItem = this.selection;
					var element = listItem.menuItem;
					if( !element.notCloseMenu ){
						this.window.close();
						if( paletteType )
							delete CM;
						}
					else
						this.selection = null;
					try{ element.action(EVENT, listItem) }catch(err){script.alertError(err)}
					}
				if( script.addMouseMove ){
					script.addMouseMove( { target: CM.BOX, direction: [true, true], withFunct: function(move){CM.location = [CM.location[0]+move[0], CM.location[1]+move[1]]}, notMoveTarget: true } );
					}
				CM.refreshItem = function( listItem ){
					 if( imagesStatus ) 
						item.subItems[0].text = listItem.menuItem.name;
					else
						item.text = listItem.menuItem.name;
					}
				
				}catch(err){ script.alertError( err ); }
				}
			}
		}
	}

// =========================================================================
// END LIB
// =========================================================================
}
}
scriptPalette_main();
